function CASWindowOpen(url, name, params)
{
   var win = window.open(url, name, params);
   if ((win == null) || (win.location == null))
   {
         alert('Unable to open popup window.  Please consult the Troubleshooting section of the Online Help.')
         win = null;
   }
   return win;
}

function openTestWindow(testURL)
{
   if (!hasRightVersion)
   {
      alert('Please first install Flash Version 6 or upwards');
   }
   else
   {
      var params ='width=800, height=650, left='+(screen.width-800)/2+',top='+(screen.height-700)/2+',directories=0,location=0,menubar=0,scrollbars=0,status=0,toolbar=0,resizable=1';
      var win = CASWindowOpen('','take_test',params);
      if (win != null)
      {
           var currentURL = new String(win.location);
         if ( (currentURL.indexOf('about:blank') != -1)    // window has just been created
          || (currentURL.indexOf('action=workspace') != -1) ) // Opera gives new window the same URL as the opener
         {
            win.location = testURL;
         }
         else if ( (currentURL.indexOf('Cas.wss?') != -1)    // window already exists, and is running CAS
             && ((currentURL.indexOf('action=load_test') != -1)    // Opera gives new window the same URL as the opener, action=workspace
            || (currentURL.indexOf('action=preload_test') != -1)) )
         {
            alert('Test is already in progress');
         }
         else
         {
             alert('Problem creating popup.  Current URL: ' + currentURL);
         }
         win.focus();
      }
   }
}

function viewCertificate(url, test_id)
{
   var nextURL = url + "&test=" + test_id;
   var params;
   var cert_format = 'portrait';

   if (test_id.toUpperCase().indexOf('STG') != -1)
   {
         cert_format = 'landscape';
   }

   if (cert_format == 'portrait')
   {
        params ='width=800, height=550, left='+(screen.width-800)/2+',top='+(screen.height-600)/2+',directories=0,location=0,menubar=0,scrollbars=1,status=0,toolbar=0,resizable=1';
   }
   else
   {
        params ='width=920, height=600, left='+(screen.width-920)/2+',top='+(screen.height-600)/2+',directories=0,location=0,menubar=0,scrollbars=1,status=0,toolbar=0,resizable=1';
   }

   CASWindowOpen(nextURL,'view_cert',params);
}

function selectUserFields(url)
{
    var params ='width=200, height=600, left='+(screen.width-600)/2+',top='+200+',directories=0,location=0,menubar=0,scrollbars=1,status=0,toolbar=0,resizable=1';
    var win = CASWindowOpen(url,'user_fields',params);
   win.focus();
}

function show_assessmentURL(assessmentURL)
{
    // look for opener, and if found re-use for test
    //  can't test whether it's actually CAS as get Permission Denied error if on different server
    if ((opener != null) && (!opener.closed))
    {
        opener.location=assessmentURL;
        opener.focus();
        // window.close();
        return;
    }

    // otherwise, use this window for test
    location.replace(assessmentURL);
}

function show_assessment(offering, testCode)
{
    show_assessmentURL('http://cas.be.ibm.com/services/weblectures/cas/Cas.wss?action=workspace&offering=' + offering + '&testsession=' + testCode + '001');
}