﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved

var m_arrAnimationInterval = new Array();

// Begin Get Names API

function GetCourseName() {
	var objNav = findNav(1);
	if (objNav != null) {
		return objNav.ALIASNAME;
	} else {
		return "";
	}
}

function GetEventName() {
    return GetEventNameFromID(m_lEventID);
}


function GetEventNameFromID(lEventID) {
	var objEvent = findEvent(lEventID);
	return objEvent.NAME;
}

function GetFrameNameForFrameNum(nIdx) {
	var objEvent = findEvent(m_lAliasID);
	if (objEvent.arrFrameNames != null) {
		if (objEvent.arrFrameNames[nIdx] != null) {
			return objEvent.arrFrameNames[nIdx];
		} else {
			return "frame" + nIdx;
		}	
	} else {
		return "frame" + nIdx;
	}	
}

function GetParentEventName() {
	var objNavLink = findNavLink(1,m_lAliasID);
	var objParentNavLink = findNavLink(2,objNavLink.ORGID);
	var lParentID = parseInt(objParentNavLink.ORGID);
	var objEvent = findEvent(lParentID);
	if (objEvent != null) {
		return objEvent.NAME;
	} else {
		return "";
	}
}

function GetParentNavName() {
	var objNavLink = findNavLink(1,m_lAliasID);
	var objNav = findNav(objNavLink.ORGID);
	if (objNav != null) {
		return objNav.ALIASNAME;
	} else {
		return "";
	}
}

// Added by JJB...10/12/2004
function GetFrameObject(sFrameObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	
	return windowtarget.document.getElementById("div_" + sFrameObjectName);
}

function GetCurrentFrameObjectName(obj) {
	return obj.id.substring(4);
}

function GetButtonNavName(nIndex) {
	var objNavLink = findNavLinkWithOrgAndSeq(1,m_lAliasID,nIndex);
	var objNav = findNav(objNavLink.DSTID);
	if (objNav != null) {
		return objNav.ALIASNAME;
	} else {
		return "";
	}
}

// End Get Names API

// Begin Breadcrumbs API

function GetBreadcrumbs() {
	var objEvent = findEvent(m_lEventID);
	return buildBreadcrumb(m_lEventID,objEvent.NAME + " ");
}

function GetBreadcrumbsNoURL() {
	var objEvent = findEvent(m_lEventID);
	return buildBreadcrumbNoURL(m_lEventID,objEvent.NAME + " ");
}


// End Breadcrumbs API

// Begin Replace functions API

function ReplaceWithExpression(sFrameListObjectName,sExpr,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	objectID = "div_" + sFrameListObjectName;
	if (windowtarget.document.getElementById(objectID).firstChild.nodeName != "#text") {
		windowtarget.document.getElementById(objectID).firstChild.innerHTML = sExpr;
	} else {
		windowtarget.document.getElementById(objectID).innerHTML = sExpr;
    }
}

function ReplaceWithContent(sFrameListObjectName,sSrcFrameListObjectName,bKeepFormatting,windowtarget,srcwindowtarget) {
	if (bKeepFormatting == null) {
		bKeepFormatting = true;
	}
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (srcwindowtarget == null) {
		srcwindowtarget = parent.content;
	}

	if (bKeepFormatting) {
        if (windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.nodeName != "#text") {
		    windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).firstChild.innerHTML;
        } else {
		    windowtarget.document.getElementById("div_" + sFrameListObjectName).innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).innerHTML;
        }        
	} else {
        if (windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.nodeName != "#text") {
		    windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).firstChild.innerText;
        } else {
		    windowtarget.document.getElementById("div_" + sFrameListObjectName).innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).innerText;
        }
	}	
}

function ReplaceButtonWithExpression(sFrameListObjectName,sExpr,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	objectID = "div_lbl_" + sFrameListObjectName;
	if (windowtarget.document.getElementById(objectID).firstChild.firstChild.nodeName != "#text") {
		windowtarget.document.getElementById(objectID).firstChild.firstChild.innerHTML = sExpr;
	} else {
		windowtarget.document.getElementById(objectID).firstChild.innerHTML = sExpr;
	}
}

function ReplaceWithCourseName(sFrameListObjectName,windowtarget) {
	ReplaceWithExpression(sFrameListObjectName,GetCourseName(),windowtarget);
}

function ReplaceWithEventName(sFrameListObjectName,windowtarget) {
	ReplaceWithExpression(sFrameListObjectName,GetEventName(),windowtarget);
}

function ReplaceWithParentEventName(sFrameListObjectName,windowtarget) {
	ReplaceWithExpression(sFrameListObjectName,GetParentEventName(),windowtarget);
}

function ReplaceWithParentNavName(sFrameListObjectName,windowtarget) {
	ReplaceWithExpression(sFrameListObjectName,GetParentNavName(),windowtarget);
}

function ReplaceWithBreadcrumbs(sFrameListObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var objectID = "div_" + sFrameListObjectName;
	var objEvent = findEvent(m_lAliasID);
	if (windowtarget.document.getElementById(objectID) != null) {
		windowtarget.document.getElementById(objectID).innerHTML = buildBreadcrumb(m_lAliasID,objEvent.NAME + " ");
	}
}

function ReplaceButtonWithNavName(sFrameListObjectName,nIndex,windowtarget) {
	ReplaceButtonWithExpression(sFrameListObjectName,GetButtonNavName(nIndex),windowtarget);
}

function GetContent(sFrameListObjectName,bKeepFormatting,windowtarget) {
	if (bKeepFormatting == null) {
		bKeepFormatting = true;
	}
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var obj = windowtarget.document.getElementById("div_" + sFrameListObjectName);
	if (obj != null) {
		if (bKeepFormatting) {
			if (obj.firstChild.nodeName != "#text") {
				return obj.firstChild.innerHTML;
			} else {
				return obj.innerHTML;
			}	
		} else {
			if (obj.firstChild.nodeName != "#text") {
				return obj.firstChild.innerText;
			} else {
				return obj.innerText;
			}
		}
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetContent(sFrameListObjectName,sContent,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var obj = windowtarget.document.getElementById("div_" + sFrameListObjectName);
	if (obj != null) {
		if (obj.firstChild.nodeName != "#text") {
			obj.firstChild.innerHTML = sContent;
		} else {
			obj.innerHTML = sContent;
		}	
	}
}


// Added by JJB 10/12/2004 - pi.xml needs updated
function GetText(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nodeName != "#text") {
			return obj.firstChild.innerHTML;
		} else {
			return obj.innerHTML;
		}	
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetText(sFrameObjectName,sText,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nodeName != "#text") {
			obj.firstChild.innerHTML = sText;
		} else {
			obj.innerHTML = sText;
		}	
	}
}

function GetOptionCaption(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
			return obj.firstChild.nextSibling.firstChild.innerHTML;
		} else {
			return obj.firstChild.nextSibling.innerHTML;
		}	
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetOptionCaption(sFrameObjectName,sCaption,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget)
	if (obj != null) {
		if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
			obj.firstChild.nextSibling.firstChild.innerHTML = sCaption;
		} else {
			obj.firstChild.nextSibling.innerHTML = sCaption;
		}	
	}
}

function SetOptionChecked(sFrameObjectName,bChecked,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if(bChecked.length != undefined) {
				obj.firstChild.checked = (bChecked.toLowerCase()=="true"?true:false);
			}	else {
				obj.firstChild.checked = bChecked;
			}
	}
}

function GetOptionChecked(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
			return obj.firstChild.checked;
		}	
}


function GetCheckboxCaption(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
			return obj.firstChild.nextSibling.firstChild.innerHTML;
		} else {
			return obj.firstChild.nextSibling.innerHTML;
		}	
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetCheckboxCaption(sFrameObjectName,sCaption,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
			obj.firstChild.nextSibling.firstChild.innerHTML = sCaption;
		} else {
			obj.firstChild.nextSibling.innerHTML = sCaption;
		}	
	}
}

function SetCheckboxChecked(sFrameObjectName,bChecked,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.length != undefined) {	
			obj.firstChild.checked = (bChecked.toLowerCase()=="true"?true:false);
		} else {
			obj.firstChild.checked = bChecked;
		}
	}	
}

function GetCheckboxChecked(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
			return obj.firstChild.checked;
		}	
}

function GetEditboxValue(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		if (obj.firstChild.nodeName == "INPUT"){
	   		return obj.firstChild.value;
	   	}else{ // an editbox label was set
	   		return obj.children[1].value;
	   	}	
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetEditboxValue(sFrameObjectName,sValue,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		obj.firstChild.value = sValue;
	}
}

function GetImage(sFrameObjectName,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		return unescape(obj.firstChild.src.replace("file:///",""));
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}	
}

function SetImage(sFrameObjectName,sSrc,windowtarget) {
	var obj = GetFrameObject(sFrameObjectName,windowtarget);
	if (obj != null) {
		obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
	}
}

function GetButtonCaption(sFrameObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var obj = windowtarget.document.getElementById("div_lbl_" + sFrameObjectName);
	if (obj != null) {
		if (obj.firstChild.firstChild.nodeName != "#text") {
			return obj.firstChild.firstChild.innerHTML;
		} else {
			return obj.firstChild.innerHTML;
		}	
	} else {
		alert("Error! The object " + sFrameObjectName + " doesn't exist.");
		return "";
	}
}

function SetButtonCaption(sFrameObjectName,sCaption,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var obj = windowtarget.document.getElementById("div_lbl_" + sFrameObjectName);
	if (obj != null) {
		if (obj.firstChild.firstChild.nodeName != "#text") {
			obj.firstChild.firstChild.innerHTML = sCaption;
		} else {
			obj.firstChild.innerHTML = sCaption;
		}	
	}	
}

function GetButtonImage(sFrameObjectName,sState,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (sState.toLowerCase() == "enabled") {
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].ENABLEDSTATE;
	} else if (sState.toLowerCase() == "highlight")	{
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].HIGHLIGHTSTATE;
	} else if (sState.toLowerCase() == "disabled")	{
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].DISABLEDSTATE;
	}
}

function SetButtonImage(sFrameObjectName,sState,sSrc,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	sState = sState.toLowerCase();

	if (sState == "enabled") {	
		windowtarget.arrContent[sFrameObjectName].ENABLEDSTATE = sSrc;
	} else if (sState == "highlight") {
		windowtarget.arrContent[sFrameObjectName].HIGHLIGHTSTATE = sSrc;
	} else if (sState == "disabled") {
		windowtarget.arrContent[sFrameObjectName].DISABLEDSTATE = sSrc;
	}	
	
	// If a current state exists
	if (windowtarget.arrContent[sFrameObjectName].CURRENTSTATE != null) {
		if (windowtarget.arrContent[sFrameObjectName].CURRENTSTATE.toLowerCase() == sState) {
			var obj = GetFrameObject(sFrameObjectName,windowtarget);
			if (obj != null) {
				obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
			}	
		}
	} else {
		if (windowtarget.arrContent[sFrameObjectName].DEFAULTSTATE != null) {
			if (windowtarget.arrContent[sFrameObjectName].DEFAULTSTATE.toLowerCase() == sState) {
				var obj = GetFrameObject(sFrameObjectName,windowtarget);
				if (obj != null) {
					obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		} else if (sState == "enabled") {
			var obj = GetFrameObject(sFrameObjectName,windowtarget);
			if (obj != null) {
				obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
			}	
		}
	}
}

function GetMultistateImage(sFrameObjectName,sState,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (sState.toLowerCase() == "state 1") {
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].STATE1;
	} else if (sState.toLowerCase() == "state 2")	{
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].STATE2;
	} else if (sState.toLowerCase() == "state 3")	{
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].STATE3;
	} else if (sState.toLowerCase() == "state 4")	{
		return m_sContentDir + "/media/" + windowtarget.arrContent[sFrameObjectName].STATE4;
	}
}

function SetMultistateImage(sFrameObjectName,sState,sSrc,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	sState = sState.toLowerCase();

	if (sState == "state 1") {	
		windowtarget.arrContent[sFrameObjectName].STATE1 = sSrc;
	} else if (sState == "state 2") {
		windowtarget.arrContent[sFrameObjectName].STATE2 = sSrc;
	} else if (sState == "state 3") {
		windowtarget.arrContent[sFrameObjectName].STATE3 = sSrc;
	} else if (sState == "state 4") {
		windowtarget.arrContent[sFrameObjectName].STATE4 = sSrc;
	}	
	
	// If a current state exists
	if (windowtarget.arrContent[sFrameObjectName].CURRENTSTATE != null) {
		if (windowtarget.arrContent[sFrameObjectName].CURRENTSTATE.toLowerCase() == "" && sState == "state 1") {
			var obj = GetFrameObject(sFrameObjectName,windowtarget);
			if (obj != null) {
				obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
			}	
		} else if (windowtarget.arrContent[sFrameObjectName].CURRENTSTATE.toLowerCase() == sState) {
			var obj = GetFrameObject(sFrameObjectName,windowtarget);
			if (obj != null) {
				obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
			}	
		}
	} else {
		if (windowtarget.arrContent[sFrameObjectName].DEFAULTSTATE != null) {
			if (windowtarget.arrContent[sFrameObjectName].DEFAULTSTATE.toLowerCase() == sState) {
				var obj = GetFrameObject(sFrameObjectName,windowtarget);
				if (obj != null) {
					obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		} else if (sState == "state 1") {
			var obj = GetFrameObject(sFrameObjectName,windowtarget);
			if (obj != null) {
				obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
			}	
		}
	}
}

// End Replace functions API


// Begin Animation Functions API

function CreateAnimationGroup(sFrameListObjects,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var arrFLObjects = sFrameListObjects.split(';');
	var arrAnimGroup = new Array(arrFLObjects.length);
	for (var i=0; i<arrFLObjects.length;i++) {
		arrAnimGroup[i] = new Array(3);
	}

	for (var i=0; i<arrFLObjects.length;i++) {
          if (windowtarget.document.getElementById("div_" + arrFLObjects[i]) != null) {
		arrAnimGroup[i][0] = arrFLObjects[i];
		arrAnimGroup[i][1] = windowtarget.document.getElementById("div_" + arrFLObjects[i]).offsetLeft;
		arrAnimGroup[i][2] = windowtarget.document.getElementById("div_" + arrFLObjects[i]).offsetTop;
		arrAnimGroup[i][3] = Number(windowtarget.document.getElementById("div_" + arrFLObjects[i]).style.width.replace("px",""));
		arrAnimGroup[i][4] = Number(windowtarget.document.getElementById("div_" + arrFLObjects[i]).style.height.replace("px",""));
          }
	}

	return arrAnimGroup;
}

function MoveAnimationGroup(arrAnimGroup,x,y,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var offsetX = x-arrAnimGroup[0][1];
	var offsetY = y-arrAnimGroup[0][2];
	
	for (var i=0; i<arrAnimGroup.length;i++) {
		CP.MoveObject(arrAnimGroup[i][0],arrAnimGroup[i][1]+offsetX,arrAnimGroup[i][2]+offsetY,windowtarget);
	}
}

function CreateAnimationGroupFromLayer(sLayerName,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var sFrameListObjects = GetObjectsInLayer(sLayerName);
	return CreateAnimationGroup(sFrameListObjects,windowtarget);
}	

function MoveAnimationLayer(arrAnimGroup,x,y,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var nEndingX = 50000;
	var nEndingY = 50000;
	for (var i=0;i<arrAnimGroup.length;i++){
		if (Number(arrAnimGroup[i][1]) < Number(nEndingX)){
			nEndingX = Number(arrAnimGroup[i][1]);
		}
		if (Number(arrAnimGroup[i][2]) < Number(nEndingY)){
			nEndingY = Number(arrAnimGroup[i][2]);
		}
	}

	var offsetX = x-nEndingX;
	var offsetY = y-nEndingY;
	
	for (var i=0; i<arrAnimGroup.length;i++) {
		CP.MoveObject(arrAnimGroup[i][0],arrAnimGroup[i][1]+offsetX,arrAnimGroup[i][2]+offsetY,windowtarget);
	}
}

function FlyInLayerFromLeft(sLayerName,nSpeed,funcOnDoneMove,nStartX,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var animationGroup = CP.CreateAnimationGroupFromLayer(sLayerName,windowtarget);

	var nEndingX = 50000;
	var nEndingY = 50000;
	var nLayerWidth = 0;
	for (var i=0;i<animationGroup.length;i++){
		if (Number(animationGroup[i][1]) < Number(nEndingX)){
			var oEndX = animationGroup[i][0]; 
			nEndingX = Number(animationGroup[i][1]);
		}
		if (Number(animationGroup[i][2]) < Number(nEndingY)){
			var oEndY = animationGroup[i][0]; 
			nEndingY = Number(animationGroup[i][2]);	
		}
		if (Number(animationGroup[i][1] + animationGroup[i][3]) > nLayerWidth){
			nLayerWidth = Number(animationGroup[i][1] + animationGroup[i][3]);	
		}
	}
	
var xStop = 0;
var yStop = 0;
if (nStartX == "" || nStartX == null){
	var curx = eval(-nLayerWidth);
}else{
	var curx = Number(nStartX);
}
var cury = nEndingY;
CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);
var nInter = setInterval(function(){if (Number(CP.GetFrameObject(oEndX,windowtarget).style.left.replace("px",""))+nSpeed< nEndingX){curx=curx+nSpeed}else{xStop++};if(xStop>0){clearInterval(nInter);curx=nEndingX;cury=nEndingY;eval(funcOnDoneMove);};CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);},100);	
m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;	
}

function FlyInLayerFromRight(sLayerName,nSpeed,funcOnDoneMove,nStartX,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var animationGroup = CP.CreateAnimationGroupFromLayer(sLayerName,windowtarget);

	var nEndingX = 50000;
	var nEndingY = 50000;
	var nLayerWidth = 0;
	for (var i=0;i<animationGroup.length;i++){
		if (Number(animationGroup[i][1]) < Number(nEndingX)){
			var oEndX = animationGroup[i][0]; 
			nEndingX = Number(animationGroup[i][1]);
			nLayerWidth = nEndingX;
		}
		if (Number(animationGroup[i][2]) < Number(nEndingY)){
			var oEndY = animationGroup[i][0]; 
			nEndingY = Number(animationGroup[i][2]);	
		}
	}
	
var xStop = 0;
var yStop = 0;
nLayerWidth = nLayerWidth + screen.width;
if (nStartX == "" || nStartX == null){
	var curx = nLayerWidth;
}else{
	var curx = Number(nStartX);
}	
var cury = nEndingY;
CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);
var nInter = setInterval(function(){if (Number(CP.GetFrameObject(oEndX,windowtarget).style.left.replace("px",""))-nSpeed> nEndingX){curx=curx-nSpeed}else{xStop++};if(xStop>0){clearInterval(nInter);curx=nEndingX;cury=nEndingY;eval(funcOnDoneMove);};CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);},100);	
m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;	
}

function FlyInLayerFromTop(sLayerName,nSpeed,funcOnDoneMove,nStartY,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var animationGroup = CP.CreateAnimationGroupFromLayer(sLayerName,windowtarget);

	var nEndingX = 50000;
	var nEndingY = 50000;
	var nLayerWidth = 0;
	for (var i=0;i<animationGroup.length;i++){
		if (Number(animationGroup[i][1]) < Number(nEndingX)){
			var oEndX = animationGroup[i][0]; 
			nEndingX = Number(animationGroup[i][1]);
			nLayerWidth = nEndingX;
		}
		if (Number(animationGroup[i][2]) < Number(nEndingY)){
			var oEndY = animationGroup[i][0]; 
			nEndingY = Number(animationGroup[i][2]);	
		}
		if (Number(animationGroup[i][2] + animationGroup[i][4]) > nLayerWidth){
			nLayerWidth = Number(animationGroup[i][2] + animationGroup[i][4]);	
		}
	}
	
var xStop = 0;
var yStop = 0;
if (nStartY == "" || nStartY == null){
	var cury = eval(-nLayerWidth);
}else{
	var cury = Number(nStartY);
}
var curx = nEndingX;
CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);
var nInter = setInterval(function(){if (Number(CP.GetFrameObject(oEndY,windowtarget).style.top.replace("px",""))+nSpeed< nEndingY){cury=cury+nSpeed}else{yStop++};if(yStop>0){clearInterval(nInter);cury=nEndingY;curx=nEndingX;eval(funcOnDoneMove);};CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);},100);	
m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
}

function FlyInLayerFromBottom(sLayerName,nSpeed,funcOnDoneMove,nStartY,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var animationGroup = CP.CreateAnimationGroupFromLayer(sLayerName,windowtarget);

	var nEndingX = 50000;
	var nEndingY = 50000;
	var nLayerWidth = 0;
	for (var i=0;i<animationGroup.length;i++){
		if (Number(animationGroup[i][1]) < Number(nEndingX)){
			var oEndX = animationGroup[i][0]; 
			nEndingX = Number(animationGroup[i][1]);
		}
		if (Number(animationGroup[i][2]) < Number(nEndingY)){
			var oEndY = animationGroup[i][0]; 
			nEndingY = Number(animationGroup[i][2]);	
			//nLayerWidth = nEndingY;
		}

}
nLayerWidth = screen.height;	
var xStop = 0;
var yStop = 0;
if (nStartY == "" || nStartY == null){
	var cury = nLayerWidth;
}else{
	var cury = Number(nStartY);
}
var curx = nEndingX;
CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);
var nInter = setInterval(function(){if (Number(CP.GetFrameObject(oEndY,windowtarget).style.top.replace("px",""))-nSpeed> nEndingY){cury=cury-nSpeed}else{yStop++};if(yStop>0){clearInterval(nInter);cury=nEndingY;curx=nEndingX;eval(funcOnDoneMove);};CP.MoveAnimationLayer(animationGroup,curx,cury,windowtarget);},100);	
m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
}

function FlyIn(arrAnimationGroup,nDuration,nStartingX,nStartingY,nEndingX,nEndingY,funcOnDoneMove,windowtarget){
if (windowtarget == null) {
    windowtarget = parent.content;
}

if (nStartingX != null && nStartingY != null){
	CP.MoveAnimationGroup(arrAnimationGroup,nStartingX,nStartingY,windowtarget);		
}	

if (nStartingX == null){
	nStartingX = -1000;
}
if (nStartingY == null){
	nStartingY = -1000;
}


//get the left and top most object in the group
if (nEndingX == null || nEndingY == null){
	nEndingX = 50000;
	nEndingY = 50000;
	var xHold;
	var yHold;
	for (var i=0;i<arrAnimationGroup.length;i++){
		xHold = arrAnimationGroup[i][1];
		if (Number(xHold) < Number(nEndingX)){
			nEndingX = Number(xHold);
			var oEndX = arrAnimationGroup[i][0]; 
			
		}
		yHold = arrAnimationGroup[i][2]
		if (Number(yHold) < Number(nEndingY)){
			nEndingY = Number(yHold);
			var oEndY = arrAnimationGroup[i][0]; 	
		}
	}
}else{
	for (var i=0;i<arrAnimationGroup.length;i++){
		xHold = arrAnimationGroup[i][1];
		if (Number(xHold) < Number(nEndingX)){
			var oEndX = arrAnimationGroup[i][0]; 	
		}
		yHold = arrAnimationGroup[i][2]
		if (Number(yHold) < Number(nEndingY)){
			var oEndY = arrAnimationGroup[i][0]; 	
		}
	}
}

var xDist = nEndingX - nStartingX;
var yDist = nEndingY - nStartingY;

var xtimes= (xDist/nDuration)*100;
var ytimes= (yDist/nDuration)*100;
var ntimes = xtimes;
if (ytimes>ntimes){
	ntimes = ytimes;
}


var xpix = xDist/xtimes; 
var ypix = yDist/ytimes;


var curx = nStartingX;
var cury = nStartingY;

var nCnt = 1;
var xStop = 0;
var yStop = 0;


var nInter = setInterval(function(){if (Number(CP.GetFrameObject(oEndX,windowtarget).style.left.replace("px",""))< nEndingX){curx=curx+nDuration}else{xStop++};if (Number(CP.GetFrameObject(oEndY,windowtarget).style.top.replace("px",""))< nEndingY){cury=cury+nDuration}else{yStop++}if(xStop>0&&yStop>0){clearInterval(nInter);CP.MoveAnimationGroup(arrAnimationGroup,nEndingX,nEndingY,windowtarget);eval(funcOnDoneMove)};CP.MoveAnimationGroup(arrAnimationGroup,curx,cury,windowtarget);},100);
m_arrAnimationInterval[m_arrAnimationInterval.length+1] = nInter;
}

// End Animation Functions API

// Begin Multistate Button/Image Functions API

function SetButtonState(sFrameListObjectName,sState,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (windowtarget.document.images['btn_' + sFrameListObjectName] == null) {
		return;
	}

        var sMediaPath = m_sContentDir + "/media/";
	if (String(sState).toLowerCase() == "enabled") {
		windowtarget.document.images['btn_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].ENABLEDSTATE;
	} else if (String(sState).toLowerCase() == "highlight") {
		windowtarget.document.images['btn_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].HIGHLIGHTSTATE;
	} else if (String(sState).toLowerCase() == "disabled") {
		windowtarget.document.images['btn_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].DISABLEDSTATE;
	}	
	
	if (String(sState).toLowerCase() == "enabled" || String(sState).toLowerCase() == "highlight") {
		windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE = "enabled";
	} else if (String(sState).toLowerCase() == "disabled") {
		windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE = sState.toLowerCase();
	}
}

function GetButtonState(sFrameListObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (convertNull(windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE) == "") {
		return windowtarget.arrContent[sFrameListObjectName].DEFAULTSTATE;
	}	
	return windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE;
}	

function IsButtonEnabled(sFrameListObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var obj = windowtarget.arrContent[sFrameListObjectName];
	if (obj.CURRENTSTATE == null) {
		if (obj.DEFAULTSTATE == null) {
			return true;
		}
		if  (obj.DEFAULTSTATE != "disabled") {
			return true;
		} else {
			return false;
		}	
	}
	if (windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE == "") {
		if (obj.DEFAULTSTATE == null) {
			return true;
		}
		if (obj.DEFAULTSTATE != "disabled") {
			return true;
		} else {
			return false;
		}	
	}
	if (windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE != "disabled") {
		return true;
	} else {
		return false;
	}
}

function SetMultistateImageState(sFrameListObjectName,sState,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (windowtarget.document.images['msi_' + sFrameListObjectName] == null) {
		return;
	}
	var sMediaPath = m_sContentDir + "/media/";
	if (String(sState).toLowerCase() == "state 1") {
		windowtarget.document.images['msi_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].STATE1;
	} else if (String(sState).toLowerCase() == "state 2") {
		windowtarget.document.images['msi_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].STATE2;
	} else if (String(sState).toLowerCase() == "state 3") {
		windowtarget.document.images['msi_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].STATE3;
	} else if (String(sState).toLowerCase() == "state 4") {
		windowtarget.document.images['msi_' + sFrameListObjectName].src = sMediaPath + windowtarget.arrContent[sFrameListObjectName].STATE4; 
	}	
	windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE=sState.toLowerCase();
}

function GetMultistateImageState(sFrameListObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (convertNull(windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE) == "") {
		return windowtarget.arrContent[sFrameListObjectName].DEFAULTSTATE;
	}	
	return windowtarget.arrContent[sFrameListObjectName].CURRENTSTATE;
}	


// End Multistate Button/Image Functions API



// Begin Layer functions API

function ShowLayer(sLayerName, targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	var obj;
	
	if (targetwindow.arrCPLayers[sLayerName] == null){
		return;
	}		
	
	for (obj in targetwindow.arrCPLayers[sLayerName].OBJECTS){
		if (obj != "") {
			CP.SetVisibility(obj,'visible',targetwindow);
		}	
	}
	m_sLayerName = sLayerName;	
}

function HideLayer(sLayerName, targetwindow, bUseDelta){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	var obj;
	
	if (bUseDelta == null) {
		bUseDelta = false;
	}
	
	if (targetwindow.arrCPLayers[sLayerName] == null){
		return;
	}
	
	for (obj in targetwindow.arrCPLayers[sLayerName].OBJECTS){
		if (obj != "") {
			if (targetwindow.arrContent[obj].DELTA != null && bUseDelta) {
				if (targetwindow.arrContent[obj].DELTA.toLowerCase() == "true") {
				} else {
					CP.SetVisibility(obj,'hidden',targetwindow);
				}
			} else {	
				CP.SetVisibility(obj,'hidden',targetwindow);
			}	
		}	
	}	
}

function ShowCascadingLayer(sLayerName, targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
		
	var sName = sLayerName;
	while (sName.indexOf("_")  != -1){
		ShowLayer(sName,targetwindow);
		sName = sName.substring(0,sName.lastIndexOf("_"));
	}
	ShowLayer(sName,targetwindow);
}

function HideCascadingLayer(sLayerName, targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	var sName = sLayerName;
	while (sName.indexOf("_")  != -1){
		HideLayer(sName,targetwindow);
		sName = sName.substring(0,sName.lastIndexOf("_"));
	}
	HideLayer(sName,targetwindow);
}

function GetTotalLayers(targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	if (targetwindow.arrCPLayers == null){
		return 0;
	}else{
		var obj;
		var icnt = 0;
		for (obj in targetwindow.arrCPLayers){
			icnt++;
		}	
		return icnt;
	}			
}

function GetCurrentLayerIndex(targetwindow){
	return GetLayerIndex(m_sLayerName,targetwindow);
}

function GetLayerIndex(sLayerName,targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	if (targetwindow.arrCPLayers == null){
		return 0;
	}else{
		var obj;
		var icnt = 1;
		for (obj in targetwindow.arrCPLayers){
			if (obj == sLayerName){
				break;
			}	
			icnt++;
		}	
		return icnt;
	}			
}
	

function GetObjectsInLayer(sLayerName, targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	var obj;
	var sFrameListObjects = "";
	for (obj in targetwindow.arrCPLayers[sLayerName].OBJECTS){
		if (obj != ""){	
			sFrameListObjects = sFrameListObjects + ";" + obj;
		}	
	}		
	sFrameListObjects = sFrameListObjects.substring(1);
	return sFrameListObjects;
}	

function GetLayerNameFromObject(sFramelistObjectName, targetwindow){
	if (targetwindow == null){
		targetwindow = parent.content;
	}
	var aobj;
	for (aobj in targetwindow.arrCPLayers){
			var obj;
			for (obj in targetwindow.arrCPLayers[aobj].OBJECTS){
				if (obj != null) {
					if (obj == sFramelistObjectName){
						return targetwindow.arrCPLayers[aobj].NAME;
					}			
				}	
			}	
	}	
}	

// End Layer functions API

// Begin Object Functions API

function MoveObject(sFrameListObjectName,x,y,windowtarget) {
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		domStyle.left = String(x) + "px";
		domStyle.top = String(y) + "px";
	}	
}


function ResizeObject(sFrameListObjectName,x,y,width,height,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		var nOldWidth = parseInt(domStyle.width);
		var nOldHeight = parseInt(domStyle.height);

		domStyle.width = width + "px";
		domStyle.height = height + "px";
		domStyle.left = x + "px";
		domStyle.top = y + "px";
		
		var sType = windowtarget.arrContent[sFrameListObjectName].TYPE;
		if (sType.toLowerCase() == "multistatebutton"){
			if (windowtarget.document.getElementById("btn_" + sFrameListObjectName) != null) {
				windowtarget.document.getElementById("btn_" + sFrameListObjectName).width = width;
				windowtarget.document.getElementById("btn_" + sFrameListObjectName).height = height;
			}	
			if (windowtarget.document.getElementById("div_lbl_" + sFrameListObjectName) != null) {
				var lblStyle = windowtarget.document.getElementById("div_lbl_" + sFrameListObjectName).style;
			
				var nOldGutterRight = nOldWidth - (parseInt(lblStyle.left) + parseInt(lblStyle.width));
				var nOldGutterBottom = nOldHeight - (parseInt(lblStyle.top) + parseInt(lblStyle.height));
				
				windowtarget.document.getElementById("div_lbl_" + sFrameListObjectName).style.width = String(width-nOldGutterRight) + "px";
				windowtarget.document.getElementById("div_lbl_" + sFrameListObjectName).style.height = String(height-nOldGutterBottom) + "px";
			}	
		}else if(sType.toLowerCase() == "image" || sType.toLowerCase() == "multistateimage"){
			if (windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild != null) {
				windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.width = width;
				windowtarget.document.getElementById("div_" + sFrameListObjectName).firstChild.height = height;
			}	
		}else if (sType.toLowerCase() == "video" || sType.toLowerCase() == "flash" || sType.toLowerCase() == "audio" || sType.toLowerCase() == "iframe" || sType.toLowerCase() == "simulation") {
			if (windowtarget.document.getElementById(sFrameListObjectName) != null) {
				windowtarget.document.getElementById(sFrameListObjectName).width = width;
				windowtarget.document.getElementById(sFrameListObjectName).height = height;
			}	
		}else if (sType.toLowerCase() == "hotspot") {
			if (windowtarget.document.getElementById("spt_" + sFrameListObjectName) != null) {
				windowtarget.document.getElementById("spt_" + sFrameListObjectName).width = width;
				windowtarget.document.getElementById("spt_" + sFrameListObjectName).height = height;
			}	
		}else if (sType.toLowerCase() == "editbox") {
			if (windowtarget.document.getElementById(sFrameListObjectName) != null) {
				var editStyle = windowtarget.document.getElementById(sFrameListObjectName).style;
			
				editStyle.width = String(width-5) + "px";
				editStyle.height = String(height-5) + "px";
			}	
		}
	}	
}

function ResizeObject2(sFrameListObjectName,x,y,width,height,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		domStyle.width = String(width) + "px";
		domStyle.height = String(height) + "px";
		domStyle.left = String(x) + "px";
		domStyle.top = String (y) + "px";
	}	
}

function SetVisibility(sFrameListObjectName,sState,windowtarget) {
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		domStyle.visibility = sState;
	}
}

function GetVisibility(sFrameListObjectName,windowtarget) {
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		return domStyle.visibility;
	} else {
          return "";
        }
}

function SetLayer(sFrameListObjectName,nZIndex,windowtarget) {
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		domStyle.zIndex = nZIndex;
	}	
}

function GetLayer(sFrameListObjectName,windowtarget) {
	domStyle = findDOM("div_" + sFrameListObjectName,1,windowtarget);
	if (domStyle != null) {
		if (domStyle.zIndex != null) {
			return domStyle.zIndex;
		}
	}	
	return null;
}



// End Object Functions API

// Begin non api support functions

function buildBreadcrumb(lEventID,sURL) {
	var objNavLink = findNavLink(1,lEventID);
	var objParentNavLink = findNavLink(2,objNavLink.ORGID);
	var lParentID = parseInt(objParentNavLink.ORGID);
	var objEvent;
	if (lParentID > 1) {
		objEvent = findEvent(lParentID);
		sURL = "<a href='#' onclick='CP.GotoEvent(" + lParentID + "); return false;'>" + objEvent.NAME + "</a> &gt; " + sURL;
		return buildBreadcrumb(lParentID,sURL);
	}
	return sURL;
}

function buildBreadcrumbNoURL(lEventID,sURL) {
	var objNavLink = findNavLink(1,lEventID);
	var objParentNavLink = findNavLink(2,objNavLink.ORGID);
	var lParentID = parseInt(objParentNavLink.ORGID);
	var objEvent;
	if (lParentID > 1) {
		objEvent = findEvent(lParentID);
		sURL = objEvent.NAME + " &gt; " + sURL;
		return buildBreadcrumbNoURL(lParentID,sURL);
	}
	return sURL;
}

// End non api support functions



	