﻿function CAudio(sAudioObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.audioObject								=	sAudioObject;
	this.parentEngine								=	parent.engine;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}

	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.audioObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();

	if(sAudioObject != null && this.isFrameObjectExists == true) {
		if(this.windowTarget.arrContent[this.audioObject] != null) {
			this.filename										=	this.windowTarget.arrContent[this.audioObject].FILENAME;
			this.altHTML										=	this.windowTarget.arrContent[this.audioObject].ALTHTML;
			this.showControls								=	this.windowTarget.arrContent[this.audioObject].SHOWCONTROLS;
			this.autoStart									=	this.windowTarget.arrContent[this.audioObject].AUTOSTART;
		}
	}
	
	
	//-------------method declaration-----------------//
	this.getAudioFilename						=	_getAudioFilename;
	this.getAudioAltHTML						=	_getAudioAltHTML;
	this.getAudioShowControls				=	_getAudioShowControls;
	this.getAudioAutoStart					=	_getAudioAutoStart;
	
	// audio.js
	this.audioPlay									=	_audioPlay;
	this.audioStop									=	_audioStop;
	this.audioPause									=	_audioPause;
	this.introAudioPlay							=	_introAudioPlay;
	this.introAudioStop							=	_introAudioStop;
	this.introAudioPause						=	_introAudioPause;
	this.toggleAudio								=	_toggleAudio;
	this.setAudioFile								= _setAudioFile;
	
	// new functions
	this.getPlayerVersion						=	_getPlayerVersion;
	this.getVolume									=	_getVolume;
	this.setVolume									=	_setVolume;
	this.nextTrack									=	_nextTrack;
	this.previousTrack							=	_previousTrack;
	this.volumeDown									=	_volumeDown;
	this.volumeUp										=	_volumeUp;
	this.muteVolume									=	_muteVolume;
	this.forward										= _forward;
	this.fastForward								=	_fastForward;
	this.setNormal									=	_setNormal;
	this.balance										=	_balance;
	
	
	//------------methods from class inheritance-----------//	
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };
	
	//-------------method definition-----------------//	
	function initialize() {
		if(sAudioObject == '[object]') {
			sAudioObject = new CFrameObject(sAudioObject).getCurrentFrameObjectName();
		}
	}
		
	function _getAudioFilename() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
		
		if(m_sAudioSupport == "wmp64") {
				var sResult = this.windowTarget.document.getElementById(this.audioObject).FileName;
		} else if(m_sAudioSupport == "wmp71") {
				var sResult = this.windowTarget.document.getElementById(this.audioObject).URL;
		}
		this.filename = sResult.replace("\\.\\","\\");
		return this.filename;
	}
	
	function _getAudioAltHTML() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		return this.altHTML;
	}
	
	function _getAudioShowControls() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		return this.showControls;
	}
	
	function _getAudioAutoStart() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		return this.autoStart;
	}
	
	function _audioPlay() {
		if (m_sAudioSupport == "wmp64") {
			this.windowTarget.document.getElementById(this.audioObject).Play();
		} else if (m_sAudioSupport == "wmp71") {
			this.windowTarget.document.getElementById(this.audioObject).controls.play();
		}
	}
		
	function _audioStop() {	
		if (m_sAudioSupport == "wmp64") {
			this.windowTarget.document.getElementById(this.audioObject).Stop();
		} else if (m_sAudioSupport == "wmp71") {
			this.windowTarget.document.getElementById(this.audioObject).controls.stop();
		}
	}
	
	function _audioPause() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
		
		if (m_sAudioSupport == "wmp64") {
			this.windowTarget.document.getElementById(this.audioObject).Pause();
		} else if (m_sAudioSupport == "wmp71") {
			this.windowTarget.document.getElementById(this.audioObject).controls.pause();
		}
	}

	function _introAudioPlay() {			
		if(m_sAudioSupport == "wmp64") {
			this.parentEngine.document.getElementById("AudioPlayer").Play();
		} else if(m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").controls.play();
		}
	}
	
	function _introAudioStop() {
		if (m_sAudioSupport == "wmp64") {
			this.parentEngine.document.getElementById("AudioPlayer").Stop();
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").controls.stop();
		}
	}
	
	function _introAudioPause() {
		if (m_sAudioSupport == "wmp64") {
			this.parentEngine.document.getElementById("AudioPlayer").pause();
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").controls.pause();
		}
	}
	
	function _toggleAudio() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		if (AuthorSettingAudio == m_sAudioSupport){
			m_sAudioSupport = "none";
		}else{
			m_sAudioSupport = AuthorSettingAudio;
		}		
	}
	
	function _setAudioFile(sAudPath) {
		if (m_sAudioSupport == "wmp64") {
			if (m_bMultiPubRel) {
				this.filename = m_sMultiCourseDir + "/media/" + sAudPath;
				return this.windowTarget.document.getElementById(this.audioObject).FileName = m_sMultiCourseDir + "/media/" + sAudPath;
			}else{
				this.filename = m_sContentDir + "/media/" + sAudPath;
				return this.windowTarget.document.getElementById(this.audioObject).FileName = m_sContentDir + "/media/" + sAudPath;
			}	
		} else if (m_sAudioSupport == "wmp71") {
			if (m_bMultiPubRel){
				this.filename = CP.m_sMultiCourseDir + "/media/" +  sAudPath;
				return this.windowTarget.document.getElementById(this.audioObject).URL = CP.m_sMultiCourseDir + "/media/" +  sAudPath;
			}else{
				this.filename = m_sContentDir + "/media/" +  sAudPath;
				return this.windowTarget.document.getElementById(this.audioObject).URL = m_sContentDir + "/media/" +  sAudPath;
			}			
		}
	}	
	
	
	// new functions
	function _getPlayerVersion() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		var player = this.windowTarget.document.getElementById(this.audioObject); 
		return player.versionInfo;
	}
	
	function _getVolume() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		var sResult = "";
		if (m_sAudioSupport == "wmp64") {
			sResult = this.parentEngine.document.getElementById("AudioPlayer").Volume;
		} else if (m_sAudioSupport == "wmp71") {
			sResult = this.parentEngine.document.getElementById("AudioPlayer").settings.volume;
		}	
		return sResult;	
	}
	
	// need to check all wmp64 settings
	
	function _setVolume(nVal) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
			// need to add condition for min & max
			this.parentEngine.document.getElementById("AudioPlayer").Volume = nVal;
			this.windowTarget.document.getElementById(this.audioObject).Settings.Volume = nVal;
		} else if (m_sAudioSupport == "wmp71") {
			if(nVal > 90) {
				nVal = 100;
			} else if(nVal < 5) {
				nVal = 0;
			}
			this.parentEngine.document.getElementById("AudioPlayer").settings.volume = nVal;
			this.windowTarget.document.getElementById(this.audioObject).settings.volume = nVal;			
		}
	}
	
	// need to check audio file with track
	function _nextTrack() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
				var player = this.parentEngine.document.getElementById("AudioPlayer");
				player.Step(1);
				this.windowTarget.document.getElementById(this.audioObject).Settings.Step = 1;
		} else if (m_sAudioSupport == "wmp71") { 
				var player = this.parentEngine.document.getElementById("AudioPlayer");
				if (player.controls.isavailable('step')) {
				player.controls.step(1);
				this.windowTarget.document.getElementById(this.audioObject).settings.step = 1;
			}
		}
	}
	
	function _previousTrack() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
				var player = this.parentEngine.document.getElementById("AudioPlayer");
				if (player.isavailable('step')) {
					player.Step(-1);
					this.windowTarget.document.getElementById(this.audioObject).Settings.Step = -1;
				}
		} else if (m_sAudioSupport == "wmp71") { 
				var player = this.parentEngine.document.getElementById("AudioPlayer");
				if (player.controls.isavailable('step')) {
					player.controls.step(-1);
					this.windowTarget.document.getElementById(this.audioObject).settings.step = -1;
			}
		}
	}
	
	function _volumeDown() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		var nVolume = this.getVolume();
		if(m_sAudioSupport == "wmp64") {
			// need to check
			nVolume += -100;
			this.setVolume(nVolume);
		} else if(m_sAudioSupport == "wmp71") {
			nVolume -= 10;
			this.setVolume(nVolume);
		}
	}
	
	function _volumeUp() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		var nVolume = this.getVolume();
		if(m_sAudioSupport == "wmp64") {
			// need to check
			nVolume -= -100;
			this.setVolume(nVolume);
		} else if(m_sAudioSupport == "wmp71") {
			nVolume += 10;
			this.setVolume(nVolume);
		}
	}
	
	function _muteVolume() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
			this.parentEngine.document.getElementById("AudioPlayer").Mute = !this.parentEngine.document.getElementById("AudioPlayer").Mute;
			this.windowTarget.document.getElementById(this.audioObject).Settings.Mute = !this.parentEngine.document.getElementById("AudioPlayer").Mute;
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").settings.mute = !this.parentEngine.document.getElementById("AudioPlayer").settings.mute;
			this.windowTarget.document.getElementById(this.audioObject).settings.mute = !this.parentEngine.document.getElementById("AudioPlayer").settings.mute;
		}		
	}
	

	function _forward() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
			
		if(m_sAudioSupport == "wmp64") {
			// need to check
			this.parentEngine.document.getElementById("AudioPlayer").Rate = 1.3;
			this.windowTarget.document.getElementById(this.audioObject).Settings.Rate = 1.3;
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").settings.rate = 1.3;
			this.windowTarget.document.getElementById(this.audioObject).settings.rate = 1.3;			
		}		
	}
	
	function _fastForward() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
			
		if(m_sAudioSupport == "wmp64") {
			// need to check
			this.parentEngine.document.getElementById("AudioPlayer").Rate = 2.0;
			this.windowTarget.document.getElementById(this.audioObject).Settings.Rate = 2.0;
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").settings.rate = 2.0;
			this.windowTarget.document.getElementById(this.audioObject).settings.rate = 2.0;			
		}		
	}
	
	function _setNormal() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
			
		if(m_sAudioSupport == "wmp64") {
			// need to check
			this.parentEngine.document.getElementById("AudioPlayer").Rate = 1.0;
			this.windowTarget.document.getElementById(this.audioObject).Settings.Rate = 1.0;
		} else if (m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").settings.rate = 1.0;
			this.windowTarget.document.getElementById(this.audioObject).settings.rate = 1.0;			
		}		
	}	
	
	
	
	function _balance(nVal) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.audioObject);
		}		
				
		var player = this.parentEngine.document.getElementById("AudioPlayer");
		
		if (m_sAudioSupport == "wmp64") {
			// need to check
			switch(player.Balance)
			{
				case 0:    //right
					player.Balance = 100;
					this.windowTarget.document.getElementById(this.audioObject).Balance = 100;		
					break;
				case 100:   //left
					player.Balance = -100;
					this.windowTarget.document.getElementById(this.audioObject).Balance = -100;		
					break;
				case -100:   //center
					player.Balance = 0;
					this.windowTarget.document.getElementById(this.audioObject).Balance = 0;		
					break;
				default :    //default
					player.Balance = 0;
					this.windowTarget.document.getElementById(this.audioObject).Balance = 0;		
					break;
			}
		} else if (m_sAudioSupport == "wmp71") {
			switch(player.settings.balance)
			{
				case 0:    //right
					player.settings.balance = 100;
					this.windowTarget.document.getElementById(this.audioObject).settings.balance = 100;		
					break;
				case 100:   //left
					player.settings.balance = -100;
					this.windowTarget.document.getElementById(this.audioObject).settings.balance = -100;		
					break;
				case -100:   //center
					player.settings.balance = 0;
					this.windowTarget.document.getElementById(this.audioObject).settings.balance = 0;		
					break;
				default :    //default
					player.settings.balance = 0;
					this.windowTarget.document.getElementById(this.audioObject).settings.balance = 0;		
					break;
			}			
		}
	}
	
	
	
	//--------------------------------------------------------//
	
}			// class


//   Copyright IBM Corp. 1998 - 2004 All Rights Reserved

// Add code in these functions to respond to the state of the media player
function audioMarkerHit(lMarkerNum) {
	// Advances to the next frame in the event; you can remove this if you want to perform a different action 
	if (m_AudioSyncAction == "Next Frame"){
		new CEvent().gotoNextFrame();
	} else if(m_AudioSyncAction == "Next Event"){
		new CEvent().gotoNextEvent();
	}  	  
}

function audioStopped() {
}

function audioPaused() {
}

function audioPlaying() {
}

function audioScanForward() {
}

function audioScanReverse() {
}

function audioBuffering() {
}

function audioWaiting() {
}

function audioMediaEnded() {
}

function audioTransitioning() {
}

function audioReady() {
}

function audioRespondToEvent(newState) {
	switch (newState){
		case 1:
			audioStopped();
	   	break;
	
		case 2:
			audioPaused();
	   	break;
	
		case 3:
			audioPlaying();
	   	break;
	
		case 4:
			audioScanForward();
	   	break;
	
		case 5:
			auudioScanReverse();
	   	break;
	
		case 6:
			audioBuffering();
	   	break;
	
		case 7:
			audioWaiting();
	   	break;
	
		case 8:
			audioMediaEnded();
	   	break;
	
		case 9:
			audioTransitioning();
	   	break;
	
		case 10:
			audioReady();
	   	break;
	
	  default:
	}
}
