﻿function CButton(sButtonObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.buttonObject								=	sButtonObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}	


	//------------class inheritance and frame object validation----------//
	var objUtil 											= new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.buttonObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
		
	if(this.windowTarget.arrContent[this.buttonObject] != null) {
			this.defaultState								=	this.windowTarget.arrContent[this.buttonObject].DEFAULTSTATE;
	}
				
	//-------------method declaration-----------------//
	this.setButtonCaption						=	_setButtonCaption;
	this.getButtonCaption						=	_getButtonCaption;
	this.setButtonImage							=	_setButtonImage;
	this.getButtonImage							=	_getButtonImage;
	this.getButtonDefaultState			=	_getButtonDefaultState;
	this.setButtonState							=	_setButtonState;
	this.getButtonState							=	_getButtonState;
	this.isButtonEnabled						=	_isButtonEnabled;

	//------------methods from class inheritance-----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };	

	//-------------method definition-----------------//
	function initialize() {
		if(sButtonObject == '[object]') {
			sButtonObject =	new CFrameObject(sButtonObject).getCurrentFrameObjectName();
		}
	}	
	
	function _setButtonCaption(sCaption) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_lbl_" + this.buttonObject);
		if (obj != null) {
			if (obj.firstChild.firstChild.nodeName != "#text") {
				obj.firstChild.firstChild.innerHTML = sCaption;
			} else {
				obj.firstChild.innerHTML = sCaption;
			}	
		}	
	}


	function _getButtonCaption() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
				
		var obj = this.windowTarget.document.getElementById("div_lbl_" + this.buttonObject);
		if (obj != null) {
			if (obj.firstChild.firstChild.nodeName != "#text") {
				return obj.firstChild.firstChild.innerHTML;
			} else {
				return obj.firstChild.innerHTML;
			}	
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.buttonObject + " doesn't exist.");
			}
			return "";
		}
	}
	
	
	function _getButtonDefaultState() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
				
		return this.defaultState;
	}
	
	
	function _getButtonImage(sState) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
						
		if (sState.toLowerCase() == "enabled") {
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.buttonObject].ENABLEDSTATE;
		} else if (sState.toLowerCase() == "highlight")	{
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.buttonObject].HIGHLIGHTSTATE;
		} else if (sState.toLowerCase() == "disabled")	{
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.buttonObject].DISABLEDSTATE;
		}
	}
	
	
	function _setButtonImage(sState,sSrc) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
				
		sState = sState.toLowerCase();
		if (sState == "enabled") {	
			this.windowTarget.arrContent[this.buttonObject].ENABLEDSTATE = sSrc;
		} else if (sState == "highlight") {
			this.windowTarget.arrContent[this.buttonObject].HIGHLIGHTSTATE = sSrc;
		} else if (sState == "disabled") {
			this.windowTarget.arrContent[this.buttonObject].DISABLEDSTATE = sSrc;
		}	
		
		// If a current state exists
		if (this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE != null) {
			if (this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE.toLowerCase() == sState) {
				var obj = this.windowTarget.document.getElementById("div_" + this.buttonObject);
				
				if (obj != null) {
					obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		} else {
			if (this.windowTarget.arrContent[this.buttonObject].DEFAULTSTATE != null) {
				if (this.windowTarget.arrContent[this.buttonObject].DEFAULTSTATE.toLowerCase() == sState) {
					var obj = this.windowTarget.document.getElementById("div_" + this.buttonObject);
					if (obj != null) {
						obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
					}	
				}
			} else if (sState == "enabled") {
				var obj = this.windowTarget.document.getElementById("div_" + this.buttonObject);
				if (obj != null) {
					obj.firstChild.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		}
	}
	

	function _setButtonState(sState) {
		if (this.windowTarget.document.images['btn_' + this.buttonObject] == null) {
			return;
		}
		
		var sMediaPath = m_sContentDir + "/media/";
		if (String(sState).toLowerCase() == "enabled") {
			this.windowTarget.document.images['btn_' + this.buttonObject].src = sMediaPath + this.windowTarget.arrContent[this.buttonObject].ENABLEDSTATE;
		} else if (String(sState).toLowerCase() == "highlight") {
			this.windowTarget.document.images['btn_' + this.buttonObject].src = sMediaPath + this.windowTarget.arrContent[this.buttonObject].HIGHLIGHTSTATE;
		} else if (String(sState).toLowerCase() == "disabled") {
			this.windowTarget.document.images['btn_' + this.buttonObject].src = sMediaPath + this.windowTarget.arrContent[this.buttonObject].DISABLEDSTATE;
		}	
			
		if (String(sState).toLowerCase() == "enabled" || String(sState).toLowerCase() == "highlight") {
			this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE = "enabled";
		} else if (String(sState).toLowerCase() == "disabled") {
			this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE = sState.toLowerCase();
		}
	}		
	
	
	function _getButtonState() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
				
		if (convertNull(this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE) == "") {
			return this.windowTarget.arrContent[this.buttonObject].DEFAULTSTATE;
		}	
		return this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE;
	}	

	function _isButtonEnabled() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.buttonObject);
		}		
				
		var obj = this.windowTarget.arrContent[this.buttonObject];
		if (obj.CURRENTSTATE == null) {
			if (obj.DEFAULTSTATE == null) {
				return true;
			}
			if  (obj.DEFAULTSTATE != "disabled") {
				return true;
			} else {
				return false;
			}	
		}
		
		if (this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE == "") {
			if (obj.DEFAULTSTATE == null) {
				return true;
			}
			if (obj.DEFAULTSTATE != "disabled") {
				return true;
			} else {
				return false;
			}	
		}
		if (this.windowTarget.arrContent[this.buttonObject].CURRENTSTATE != "disabled") {
			return true;
		} else {
			return false;
		}		
		
	}
	
	//----------------------------------------------------//
	
}				//class