﻿function CCheckbox(sCheckboxObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.checkboxObject								=	sCheckboxObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}

	//-------------method declaration-----------------//
	this.setCheckboxCaption							=	_setCheckboxCaption;
	this.getCheckboxCaption							=	_getCheckboxCaption;
	this.setCheckboxChecked							=	_setCheckboxChecked;
	this.getCheckboxChecked							=	_getCheckboxChecked;
	this.isCheckboxChecked							=	_isCheckboxChecked;
	
	
	//------------class inheritance, frame object validation & methods----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.checkboxObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	this.isGroupExists								=	objFrameObject.isObjectGroupExists();
	
	//-------------methods from inherited class-----------------//		
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };	

	//-------------method definition-----------------//	
	function initialize() {
		if(sCheckboxObject == '[object]') {
			sCheckboxObject =	new CFrameObject(sCheckboxObject).getCurrentFrameObjectName();
		}
	}
		
	function _getCheckboxCaption() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			if(m_debug == true) {
				alert("Error! Cannot perform this function for the group - " + this.checkboxObject);
			}
			return null;
		}			
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.checkboxObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.checkboxObject);
		if (obj != null) {
			if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
				return obj.firstChild.nextSibling.firstChild.innerHTML;
			} else {
				return obj.firstChild.nextSibling.innerHTML;
			}	
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.checkboxObject + " doesn't exist.");
			}
			return "";
		}
	}
	
	function _setCheckboxCaption(sCaption) {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			if(m_debug == true) {
				alert("Error! Cannot perform this function for the group - " + this.checkboxObject);
			}
			return null;
		}			
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.checkboxObject);
		}		

		var obj = this.windowTarget.document.getElementById("div_" + this.checkboxObject);
		if (obj != null) {
			if (obj.firstChild.nextSibling.firstChild.nodeName != "#text") {
				obj.firstChild.nextSibling.firstChild.innerHTML = sCaption;
			} else {
				obj.firstChild.nextSibling.innerHTML = sCaption;
			}	
		}
	}
	
	function _setCheckboxChecked(bChecked) {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			if(m_debug == true) {
				alert("Error! Cannot perform this function for the group - " + this.checkboxObject);
			}
			return null;
		}					
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.checkboxObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.checkboxObject);
		if (obj != null) {
				obj.firstChild.checked = bChecked;
				//obj.firstChild.checked = (bChecked.toLowerCase()=="true"?true:false);
			}	
	}
	
	function _getCheckboxChecked() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			if(m_debug == true) {
				alert("Error! Cannot perform this function for the group - " + this.checkboxObject);
			}
			return null;
		}					
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.checkboxObject);
		}		
		
		var obj = this.windowTarget.document.getElementById("div_" + this.checkboxObject);
		if (obj != null) {
				return obj.firstChild.checked;
			}	
	}
	
	function _isCheckboxChecked() {
		if(this.isGroupExists == true && this.isFrameObjectExists == false) {
			if(m_debug == true) {
				alert("Error! Cannot perform this function for the group - " + this.checkboxObject);
			}
			return null;
		}					
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.checkboxObject);
		}		
		
		if(Boolean(this.getCheckboxChecked()) == true) {
			return true;
		}
		else {
			return false;
		}
	}
	
	
	//-------------------------------------------//
	
}			//class