﻿function CUtil(targetwindow) {
	//-------------property declaration-----------------//
	this.parentEngine					=	parent.engine;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}	

	//-------------method declaration-----------------//
	this.getProperty										=	_getProperty;
	this.replaceAll											= _replaceAll;
	this.isNumeric											=	_isNumeric;
	this.getStringTokens								=	_getStringTokens;
	this.isFullURL											=	_isFullURL;
	this.openWindow											=	_openWindow;
	this.openWindowAndCenter						=	_openWindowAndCenter;
	this.openPersistentWindowAndCenter	=	_openPersistentWindowAndCenter;
	this.openReusableWindowAndCenter		=	_openReusableWindowAndCenter;
	this.openNewWindowAndCenter					= _openNewWindowAndCenter;
	this.openWindowFullScreen						=	_openWindowFullScreen;
	this.openModalWindow								=	_openModalWindow;
	this.openModalessWindow							=	_openModalessWindow;
	this.launchSimPro										=	_launchSimPro;	
	this.resizeBy												=	_resizeBy;
	this.moveBy													=	_moveBy;
	this.unswapImages										=	_unswapImages;
	this.getRandom											=	_getRandom;	
	this.buildFullURL										=	_buildFullURL;
	this.getContentFullURL							=	_getContentFullURL;
	this.getFullURLRelativeToEngine			=	_getFullURLRelativeToEngine;
	this.getID													=	_getID;
	this.addScriptInclude								=	_addScriptInclude;
	this.search													=	_search;
	this.handleError										=	_handleError;
	
	// new
	this.moveDIV												=	_moveDIV;
	this.getDIVOffsetX									= _getDIVOffsetX;
	this.getDIVOffsetY									= _getDIVOffsetY;
	this.getDigit												= _getDigit;
	this.showCPError										=	_showCPError;

	
	//-------------method definition-----------------//
	// lastObjName ==> get the property value until lastProperty
	function _getProperty(obj,lastProperty) {
		var result = "";
	
			for (var i in obj) {
				if(i == lastProperty) break;
				result += "objCSCO." + i + " = " + obj[i] + "\n";
			}          
	
			return result;	
	}	


	function _replaceAll(sStr,sFind,sReplace){
		if (sFind == "/"){
			rExp = /\//gi;
	    } else if (sFind == "\\"){
			rExp = /\\/gi;
		}else{
			rExp = eval("/" + sFind + "/gi");
		}	
	    
		myString = new String(sStr);
		results = myString.replace(rExp, sReplace);
		return results;
	}


	function _isNumeric(strString) {	
	   //  check for valid numeric strings	
	   var strValidChars = "0123456789.-";
	   var strChar;
	   var blnResult = true;
	
	   if (strString.length == 0) return false;
	
	   //  test strString consists of valid characters listed above
	   for (i = 0; i < strString.length && blnResult == true; i++)
	      {
	      strChar = strString.charAt(i);
	      if (strValidChars.indexOf(strChar) == -1)
	         {
	         blnResult = false;
	         }
	      }
	
	   return blnResult;
	}


	function _getStringTokens(strString, delimiter) {
		var arrResult = strString.split(delimiter);
		return arrResult;
	}
	

	function _isFullURL(sURL){
		if (sURL.substring(0,5) == "http:" || sURL.substring(0,6) == "https:" || sURL.substring(0,5) == "file:" || sURL.substring(0,4) == "ftp:" || sURL.substring(0,1) == "/" || sURL.substring(1,2) == ":"){
			return true;      
		}
		return false;
	}		

	
	function _openWindow(url,windowNumber,windowName,replace,left,top,width,height,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
		if (windowNumber==null || windowNumber==0 || windowNumber=="") windowNumber=1;
		if (windowName==null || windowName==0 || windowName=="") windowName="";
		if (replace==null || replace==0 || replace=="") replace='';
		if (String(replace).toLowerCase()=="yes") replace=true;
		if (String(replace).toLowerCase()=="no") replace=false;
		if (left==null || left==0 || left=="") left=0;
		if (top==null || top==0 || top=="") top=0;
		if (width==null || width==0 || width=="") width=800;
		if (height==null || height==0 || height=="") height=600;
		if (resizable==null || resizable==0 || resizable=="") resizable=0;
		if (scrollbars==null || scrollbars==0 || scrollbars=="") scrollbars=0;
		if (toolbar==null || toolbar==0 || toolbar=="") toolbar=0;
		if (menubar==null || menubar==0 || menubar=="") menubar=0;
		if (location==null || location==0 || location=="") location=0;
		if (status==null || status==0 || status=="") status=0;
		if (bForceRelative==null) bForceRelative = false;
	
	    if (!bForceRelative) {
			if (!this.isFullURL(url)){
				url = m_sContentDir + "/" + url;
			}		
		}
		var options = "left=" + left + ",top=" + top + ",width=" + width + ",height=" + height + 
			",resizable=" + resizable + ",scrollbars=" + scrollbars +
			",toolbar=" + toolbar + ",menubar=" + menubar + ",location=" + location + ",status=" + status;
	
		if (windowName==null || windowName=="") {
			windowName=="";
		} else {
			windowName=windowName+"_"+windowNumber;
		}
	
		// no window or window closed
		if (m_arrPopupWin[windowNumber-1] == null || m_arrPopupWin[windowNumber-1].closed) {
			m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
			return m_arrPopupWin[windowNumber-1];
		// already content in window
		} else {
			if (windowName=="") {
				m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
				return m_arrPopupWin[windowNumber-1];
			} else if (replace) {
				m_arrPopupWin[windowNumber-1]=window.open(url,windowName,options);
				m_arrPopupWin[windowNumber-1].focus();
				return m_arrPopupWin[windowNumber-1];
			} else {
				m_arrPopupWin[windowNumber-1].focus();
			}
		}
	}


	function _openWindowAndCenter(url,windowNumber,windowName,replace,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
		var screentop;
		var screenleft;
		
		screenleft = (top.screen.width-width)/2-6;
			
		if (centertop == null) {
			centertop = false;
		}
	
		if (centertop == true) {
			screentop = 0;
		} else {
			screentop = (top.screen.height-height)/2-6;
		}
		if (resizable == null) resizable = "yes";
		if (scrollbars == null) scrollbars = "yes";
		if (toolbar == null) toolbar = "no";
		if (menubar == null) menubar = "no";
		if (location == null) location = "no";
		if (status == null) status = "no";
			
		return this.openWindow(url,windowNumber,windowName,replace,screenleft,screentop,width,height,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
	}
	
	function _openPersistentWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
		return this.openWindowAndCenter(url,windowNumber,"popup",false,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
	}
	
	function _openReusableWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
		return this.openWindowAndCenter(url,windowNumber,"popup",true,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
	}
	
	function _openNewWindowAndCenter(url,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative) {
		return this.openWindowAndCenter(url,windowNumber,"",false,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,bForceRelative);
	}
	
	function _openWindowFullScreen(url,bForceRelative){
		if (bForceRelative==null) bForceRelative = false;
	
	    if (!bForceRelative) {
			if (!this.isFullURL(url)){
				url = m_sContentDir + "/" + url;
			}		
		}
	
	    return window.open(url,"","fullscreen=1");
	}	

	
	function _openModalWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative) {
		if(height==null || height==0 || height=="") height = "600";
		if(xPos==null || xPos==0 || xPos=="") xPos = "0";
		if(yPos==null || yPos==0 || yPos=="") yPos = "0";
		if(width==null || width==0 || width=="") width = "800";
		if(center==null || center==0 || center=="") center = "yes";
		if(dialogHide==null || dialogHide==0 || dialogHide=="") dialogHide = "no";
		if(edge==null || edge==0 || edge=="") edge = "raised";
		if(help==null || help==0 || help=="") help = "yes";
		if(resizable==null || resizable==0 || resizable=="") resizable = "no";
		if(scroll==null || scroll==0 || scroll=="") scroll = "yes";
		if(status==null || status==0 || status=="") status = "yes";
		if(unadorned==null || unadorned==0 || unadorned=="") unadorned = "no";
		if(bForceRelative==null) bForceRelative = false;
		
		if (!bForceRelative) {
			if (!this.isFullURL(url)) {
				url = m_sContentDir + "/" + url;
			}		
		}
		
		url = url.replace("?","%3f");
		url = url.replace("&","%3f");

		return window.showModalDialog(url,String(height),String(xPos),String(yPos),String(width),center,dialogHide,edge,help,resizable,scroll,status,unadorned,window);
	}
	
	function _openModalessWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative) {
		if(height==null || height==0 || height=="") height = "600";
		if(xPos==null || xPos==0 || xPos=="") xPos = "0";
		if(yPos==null || yPos==0 || yPos=="") yPos = "0";
		if(width==null || width==0 || width=="") width = "800";
		if(center==null || center==0 || center=="") center = "yes";
		if(dialogHide==null || dialogHide==0 || dialogHide=="") dialogHide = "no";
		if(edge==null || edge==0 || edge=="") edge = "raised";
		if(help==null || help==0 || help=="") help = "yes";
		if(resizable==null || resizable==0 || resizable=="") resizable = "no";
		if(scroll==null || scroll==0 || scroll=="") scroll = "yes";
		if(status==null || status==0 || status=="") status = "yes";
		if(unadorned==null || unadorned==0 || unadorned=="") unadorned = "no";
		if(bForceRelative==null) bForceRelative = false;
		  
		if (!bForceRelative) {
			if (!this.isFullURL(url)) {
				url = m_sContentDir + "/" + url;
			}		
		}
		
		url = url.replace("?","%3f");
		url = url.replace("&","%3f");

		
		return window.showModelessDialog(url,String(height),String(xPos),String(yPos),String(width),center,dialogHide,edge,help,resizable,scroll,status,unadorned,window);
	}

	
	function _launchSimPro(path,simType,extension,windowNumber,windowName,replace,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status) {		
		this.openWindowAndCenter(path + "/" + simType + "." + extension,windowNumber,windowName,replace,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status);
	}
	

	function _resizeBy(width,height,windowtarget) {
		if(!windowtarget.closed) {
			windowtarget.resizeBy(width,height);
		}
	}

	function _moveBy(xPos,yPos,windowtarget) {
		if(!windowtarget.closed) {
			windowtarget.moveBy(xPos,yPos);
		}
	}
	
	function _unswapImages() {
		for (var i=0;i<aSwapImages.length;i++){
			if (aSwapImages[i].name != null){
				if (aSwapImages[i].window.document.getElementById(aSwapImages[i].name) != null){
					aSwapImages[i].window.document.getElementById(aSwapImages[i].name).src=aSwapImages[i].src;
				}	
			}			
		}		
	}
	
	
	function _getRandom(count) {
		// Look at to make sure everything getting proper weight
	    var ranNum = Math.round(Math.random()*(count-1));
	    return ranNum;
	}	
	
	
	function _buildFullURL(sPath) {
		if (sPath.substring(0,4) == "http" || sPath.substring(0,4) == "file" || sPath.substring(0,3) == "ftp"){
			return sPath;
		}else{
			if (sPath.substring(0,1) == "/"){
				sPath = sPath.substring(1,sPath.length);
			}
			return this.getContentFullURL() + "/" + sPath;
		}				
	}	
	
	
	function _getContentFullURL() {
		return m_sContentDir;
	}		
	
	
	function _getFullURLRelativeToEngine(sPath){
		if (document.location.protocol.toLowerCase() != "http:" && document.location.protocol.toLowerCase() != "https:" && document.location.protocol.toLowerCase() != "file:"){
			return sPath;      
		}
		var sNewPath=document.location.href.substring(0,document.location.href.lastIndexOf("?"));
		sNewPath = sNewPath.substring(0,sNewPath.lastIndexOf("/")+1)
		return sNewPath + sPath;
	}	
	
	
	function _getID(srcElement) {
		if (srcElement == null) {
			return "";
		}
		if (srcElement.id != "" && srcElement.tagName.toLowerCase() == "div" && srcElement.id.indexOf('div_lbl_')==-1 && srcElement.id.indexOf('div_int_')==-1 && srcElement.id.indexOf('div_')>=0) {
			return srcElement.id;
		} else {
			return this.getID(srcElement.parentElement);
		}
	}	
	
	
	function _addScriptInclude(sRelativePath) {
		var elemScript = this.parentEngine.document.createElement("script");
		elemScript.setAttribute("src", sRelativePath);
		this.parentEngine.document.getElementsByTagName("head").item(0).appendChild(elemScript);
	}	
		
	function _search(sSearchTermObject,sSearchResultObject,sSearchTypeGroup,sResultMultipleCaption,sResultSingleCaption,sResultNotFound){
		SearchDB(sSearchTermObject,sSearchResultObject,sSearchTypeGroup,sResultMultipleCaption,sResultSingleCaption,sResultNotFound);
	}	


	function _handleError(sValue) {
		if(m_debug == true) {
			alert("Error! The frame object " + sValue + " doesn't exists.");
		}
		return null;
	}	
	
	// new
	function _moveDIV(id,x,y) {
	  this.windowTarget.document.getElementById(id).style.left = x + "px";
	  this.windowTarget.document.getElementById(id).style.top = y + "px";
	}
	
	function _getDIVOffsetX(id) {
	  return Number(this.windowTarget.document.getElementById(id).style.left.replace("px",""));
	}
	
	function _getDIVOffsetY(id) {
	  return Number(this.windowTarget.document.getElementById(id).style.top.replace("px",""));
	}	
	
	function _getDigit(nNum,nDigit) {
		var nDig = Math.pow(10,(nDigit-1));
		var nZero = "";
		if (Number(nNum) < nDig) {
			for(var i=0; i<nDig; i++) {
				nDig = nDig/10;
				nZero = nZero + "0";
				if (Number(nNum) >= nDig) {
					break;
				}
			}
			return nZero + nNum;
		}
		return nNum;		
	}	

	function _showCPError(bVal) {
		m_debug = bVal;
	}
	
	//------------------------------------------------//
}			// class

	
