﻿
	
	// Begin Global variable
	var m_bDebug = false;
	var m_DebugWin;
	var m_sStartTime = new Date();
	var m_interactionCount = 0;
	var allCookies = (document.cookie!="") ? document.cookie.split(";") : new Array("");
	var courseStatus = "";
	
	// End Global variable	

	
function SetCookie(sItem, sValue,lexpDays){
	var cookieExpires="";
	if ( lexpDays != 0) {
        expMins = (lexpDays * 24) * 60;
		expDate = new Date();
		expDate.setTime(expDate.getTime() + (expMins*60000))
		cookieExpires = "; expires=" + expDate.toGMTString();
	}
	document.cookie = m_sSCOID + "_" + sItem + "=" + sValue + cookieExpires + ";path=/";    
}

function GetCookie(sItem){
	sItem = m_sSCOID + "_" + sItem;		
	for( ctx=0;ctx<allCookies.length;ctx++) {
		curCookie = allCookies[ctx].split("=");
		curCookieName = (curCookie[0].charAt(0)==' ') ? curCookie[0].substring(1,curCookie[0].length) : curCookie[0];
		if ( curCookieName == sItem ) {
			return (curCookie.length > 1) ? curCookie[1] : "";
		}
	}
	return "";
}
	
	
// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved



function LMSHeartbeat() {
}

function lmsInitialize() {
	if (m_sTracking == "none") return false;
	m_lBookmarkEventID = lmsSetEventToBookmark();
}

function lmsDeinitialize() {
	if (m_sTracking == "none") return false;

	lmsCommitCompletionStatus();
}

function lmsSetEventToBookmark() {
	// Get bookmark data
	lmsSetVisitedStatus(LMSGetValue("visited"));
	// Restore the screen status information (be sure to convert this into a JavaScript string)
	if (m_bUseBookmarking) {
		tmpBKM = LMSGetValue("bm");
		if (tmpBKM != null && tmpBKM != "") {
			if (String(tmpBKM).indexOf(",") == -1) {
				m_lEventID = Number(tmpBKM);
			} else {
				m_lEventID = Number(tmpBKM.split(",")[0]);
			}
			return tmpBKM;
		}
	}
	return 0;
}

function lmsCommitCompletionStatus() {
	var sVisitedString = lmsGetVisitedString();
	// if has target set comma delimited string
	if (getTarget(m_lBookmarkEventID)) {
		var lEventID = parent.parent.content.objEvent.ID;
		LMSSetValue("bm",lEventID + "," + String(m_lBookmarkEventID));
	} else {
		LMSSetValue("bm",String(m_lBookmarkEventID));
	}	
	LMSSetValue("visited",sVisitedString);

	// There is at least one t
	var ts = sVisitedString.indexOf("t",0);
	if (ts > -1) {
		var fs = sVisitedString.indexOf("f",0);
		// There is not one f
		if (fs == -1) {
			SetCompletionStatus("completed");
		} else {
			SetCompletionStatus("incomplete");
		}
	}
}

function SetCompletionStatus(sStatus){
	if (LMSGetValue("status").toLowerCase() != "c"){
		if (sStatus == "completed"){
			LMSSetValue( "status", "c" );
		}else if (sStatus == "incomplete"){
			LMSSetValue( "status", "i" );
		}
	}	
}

function lmsReportObjStatus(sObjID){
}

function lmsGetObjectiveIndex(sObjID){
}

function lmsSetMinScore(score) {
}

function lmsSetMaxScore(score) {
}

function lmsSetScore(score) {
	LMSSetValue("score.raw",score);  		  
}

function lmsResetCompletionStatus() {
	var colEvents = findEvents();

	for (var i=0; i<colEvents.length-1;i++) {
		oEventNode = colEvents[i+1];
	    
		visited = "false";

		if (m_arrEvents[String(oEventNode.ID)].VISITED == null) {
			m_arrEvents[String(oEventNode.ID)].VISITED = "false";
		}
		m_arrEvents[String(oEventNode.ID)].VISITED = visited;	
	}

	LMSSetValue("bm","",0);  
	LMSSetValue("visited","",0);  
	LMSSetValue("status","n",0);
}
	

function lmsSetQuestionData(interactionid,type,correctResponse,studentResponse,result,latency,weight,objectiveID) {
}

function LMSSetValue(sItem, sValue){
    SetCookie(sItem,sValue,30);
}

function LMSGetValue(sItem){
	return GetCookie(sItem);
/*
	sItem = m_sSCOID + "_" + sItem;		
	for( ctx=0;ctx<allCookies.length;ctx++) {
		curCookie = allCookies[ctx].split("=");
		curCookieName = (curCookie[0].charAt(0)==' ') ? curCookie[0].substring(1,curCookie[0].length) : curCookie[0];
		if ( curCookieName == sItem ) {
			return (curCookie.length > 1) ? curCookie[1] : "";
		}
	}
	return "";
*/	
}





		
		
function lmsGetVisitedString() {
	var visitedString = "";
	var colEvents = findEvents();
	for (var i=0; i<colEvents.length;i++) {
		oEventNode = colEvents[i];

		visitedChar = "f";
		if (oEventNode.VISITED != null) {
			if (oEventNode.VISITED.toLowerCase() == "true") {
				visitedChar = "t";
			}else if (oEventNode.VISITED.toLowerCase() == "false") {
				visitedChar = "f";
			}else if (oEventNode.VISITED.toLowerCase() == "ignore") {
				visitedChar = "i";
			}
		}
		visitedString = visitedString + visitedChar;
	}

	return visitedString;
}

function lmsSetVisitedStatus(visitedString) {
	var colEvents = findEvents();
	for (var i=0; i<colEvents.length;i++) {
		oEventNode = colEvents[i];
		visited = "false";
		if (visitedString.length >= i) {
			if (visitedString.charAt(i) == "t") {
				visited = "true";
			}else if (visitedString.charAt(i) == "f") {
				visited = "false";
			}else if (visitedString.charAt(i) == "i") {
				visited = "ignore";
			}	
			m_arrEvents[String(oEventNode.ID)].VISITED = visited;	
		} else {
			// alert that hierarchy has changed
		}
		
	}
}	
	
	
		
		
		
	