﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved

function setButtonCursor(obj,sState) {
  if (obj != null) {
    obj.style.cursor=sState; 
    if (obj.firstChild != null) {
      obj.firstChild.style.cursor=sState; 
      if (obj.firstChild.nextSibling != null) {
        if (obj.firstChild.nextSibling.firstChild != null) obj.firstChild.nextSibling.firstChild.style.cursor=sState;
      }
    }  
  }  
}

function RandomNumber(maxnumber) {
    return randnumBase0(maxnumber);
} 

function randnumBase0(maxNumber) {
   return Math.floor(Math.random()*(maxNumber+1))
}

function randnumBase1(maxNumber) {
   return Math.floor(Math.random()*(maxNumber)) + 1;
}

function prefetchNextImages(windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	for (var i=0; i<windowtarget.arrNextImages.length;i++) {
		// Need to dynamically create an offscreen div so that the image gets cached
		var oElm = windowtarget.document.createElement("div");
		oElm.style.position = "absolute";
		oElm.style.top = -10000;
		oElm.style.left = -1000;
		oElm.innerHTML = "<img src='" + windowtarget.arrNextImages[i] + "'/></div>";
		windowtarget.document.body.appendChild(oElm);
	}
}

function getNavForNavLink(sNavLinkName) {
	return getNavForNavLinkForEvent(m_lAliasID,sNavLinkName);
}



function getNavForNavLinkForEvent(lEventID,sNavLinkName) {
	var colOrgNodes = findNavLinks(1,lEventID);
	var objNav;

	for (var i=0; i<colOrgNodes.length; i++) {
		lDstID = colOrgNodes[i].DSTID;

		objNav = findNav(lDstID);
		if (objNav.NAME == sNavLinkName) {
			return objNav;
		}
	}
}

function findEvents() {
	var retArr = new Array();
	var i = 0;
	for (var p=0; p<m_arrNavLinks.length; p++) {
		if ( (Number(m_arrNavLinks[p].DSTTYPE) == 1) && (Number(m_arrNavLinks[p].DSTID) > 1) ) {
			if ( (Number(m_arrNavLinks[p].DSTTYPE) == 1) )  {
				retArr[i] = m_arrEvents[String(m_arrNavLinks[p].DSTID)];
				i++;
			}
		}	
	}
	return retArr;
}

function findNavLinks(type,id) {
	var retArr = new Array();
//	var i = 0;
	for (var p=0; p<m_arrNavLinks.length; p++) {
		if ( (Number(m_arrNavLinks[p].ORGTYPE) == Number(type)) && (Number(m_arrNavLinks[p].ORGID) == Number(id)) )  {
			retArr[Number(m_arrNavLinks[p].SEQUENCE)-1] = m_arrNavLinks[p];
//			i++;
		}
	}
	return retArr;
}

function findNav(id) {
	return m_arrNavs[String(id)];
}

function findEvent(id) {
	return m_arrEvents[String(id)];
}

function findNavLink(type,id) {
	for (var p=0; p<m_arrNavLinks.length; p++) {
		if ( (Number(m_arrNavLinks[p].DSTTYPE) == Number(type)) && (Number(m_arrNavLinks[p].DSTID) == Number(id)) )  {
			return m_arrNavLinks[p];
		}
	}

	return null;
}

function findNavLinkWithOrgAndSeq(type,id,seq) {
	for (var p=0; p<m_arrNavLinks.length; p++) {
		if ( (Number(m_arrNavLinks[p].ORGTYPE) == Number(type)) && (Number(m_arrNavLinks[p].ORGID) == Number(id)) && (Number(m_arrNavLinks[p].SEQUENCE) == seq) )  {
			return m_arrNavLinks[p];
		}
	}

	return null;
}

function convertNull(sValue){
	if (sValue == null){
		sValue = "";
	}
	return sValue;	
}
function convertNullToZero(sValue){
	if (convertNull(sValue) == ""){
		sValue = 0;
	}
	return sValue;	
}

function formatTime( secTime ) {
    if (secTime <= 0 ) {
      return "00:00:00";
    }
    sHours = right( "00" +parseInt(secTime/3600), 2);
    sMins  = right( "00" +parseInt((secTime%3600)/60), 2);
    sSecs  = right( "00" +parseInt(secTime%60), 2);
    return sHours+":"+sMins+":"+sSecs;
}

function right( str, len ) {
	 return (str.length <= len) ? str : str.substring( str.length-len, str.length ); 
 }


function GetFrameObjectNameFromDOM(sObj){
	if (sObj.id == null) return null;

	if (sObj.id.indexOf("div_int_") > 0 || sObj.id.indexOf("div_lbl_") > 0){
		return GetFrameObjectNameFromDOM(sObj.parentNode);
	}
	
	if (sObj.id.indexOf("div_") == -1){
		return GetFrameObjectNameFromDOM(sObj.parentNode);
	}	
	return StripDivPrefix(sObj.id);
}	

function StripDivPrefix(sName){
	if (sName.indexOf("div_int_") != -1){
		return sName.substring(sName.indexOf("div_int_")+8,sName.length);
	}else if (sName.indexOf("div_lbl_") != -1){
		return sName.substring(sName.indexOf("div_lbl_")+8,sName.length);		
	}else if (sName.indexOf("div_") != -1){
		return sName.substring(sName.indexOf("div_")+4,sName.length);
	}
	return sName;
}	

function getDateTimestamp() {
	var d = new Date()
	var sMonth;
	if (String(d.getMonth()).length == 1) {
		sMonth = "0" + String(d.getMonth()+1);
	} else {
		sMonth = String(d.getMonth()+1);
	}
	var sDate;
	if (String(d.getDate()).length == 1) {
		sDate = "0" + String(d.getDate());
	} else {
		sDate = d.getDate();
	}
	var sHours;
	if (String(d.getHours()).length == 1) {
		sHours = "0" + String(d.getHours());
	} else {
		sHours = d.getHours();
	}
	var sMinutes;
	if (String(d.getMinutes()).length == 1) {
		sMinutes = "0" + String(d.getMinutes());
	} else {
		sMinutes = d.getMinutes();
	}
	var sSeconds;
	if (String(d.getSeconds()).length == 1) {
		sSeconds = "0" + String(d.getSeconds());
	} else {
		sSeconds = d.getSeconds();
	}
	return d.getFullYear() + "-" + sMonth + "-" + sDate + " " + sHours + ":" + sMinutes + ":" + sSeconds;
}

function Is (){
	//"Is" is the constructor function for "is" object,
	// which has properties indicating:
	// (1) browser vendor:
	//     is.nav, is.ie, is.opera, is.hotjava, is.webtv, is.TVNavigator, is.AOLTV
	// (2) browser version number:
	//     is.major (integer indicating major version number: 2, 3, 4 ...)
	//     is.minor (float   indicating full  version number: 2.02, 3.01, 4.04 ...)
	// (3) browser vendor AND major version number
	//     is.nav2, is.nav3, is.nav4, is.nav4up, is.nav6, is.nav6up, is.gecko, is.ie3, 
	//     is.ie4, is.ie4up, is.ie5, is.ie5up, is.ie5_5, is.ie5_5up, is.ie6, is.ie6up, is.hotjava3, is.hotjava3up
	// (4) JavaScript version number:
	//     is.js (float indicating full JavaScript version number: 1, 1.1, 1.2 ...)
	// (5) OS platform and version:
	//     is.win, is.win16, is.win32, is.win31, is.win95, is.winnt, is.win98, is.winme, is.win2k
	//     is.os2
	//     is.mac, is.mac68k, is.macppc
	//     is.unix
	//     is.sun, is.sun4, is.sun5, is.suni86
	//     is.irix, is.irix5, is.irix6
	//     is.hpux, is.hpux9, is.hpux10
	//     is.aix, is.aix1, is.aix2, is.aix3, is.aix4
	//     is.linux, is.sco, is.unixware, is.mpras, is.reliant
	//     is.dec, is.sinix, is.freebsd, is.bsd
	//     is.vms
	
	// convert all characters to lowercase to simplify testing
    var agt=navigator.userAgent.toLowerCase();

    // *** BROWSER VERSION ***
    // Note: On IE5, these return 4, so use is.ie5up to detect IE5.

    this.major = parseInt(navigator.appVersion);
    this.minor = parseFloat(navigator.appVersion);

    // Note: Opera and WebTV spoof Navigator.  We do strict client detection.
    // If you want to allow spoofing, take out the tests for opera and webtv.
    this.nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
                && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
                && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
    this.nav2 = (this.nav && (this.major == 2));
    this.nav3 = (this.nav && (this.major == 3));
    this.nav4 = (this.nav && (this.major == 4));
    this.nav4up = (this.nav && (this.major >= 4));
    this.navonly      = (this.nav && ((agt.indexOf(";nav") != -1) ||
                          (agt.indexOf("; nav") != -1)) );
    this.nav6 = (this.nav && (this.major == 5));
    this.nav6up = (this.nav && (this.major >= 5));
    this.gecko = (agt.indexOf('gecko') != -1);


    this.ie     = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
    this.ie3    = (this.ie && (this.major < 4));
    this.ie4    = (this.ie && (this.major == 4) && (agt.indexOf("msie 4")!=-1) );
    this.ie4up  = (this.ie  && (this.major >= 4));
    this.ie5    = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.0")!=-1) );
    this.ie5_5  = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.5") !=-1));
    this.ie5up  = (this.ie  && !this.ie3 && !this.ie4);
    this.ie5_5up =(this.ie && !this.ie3 && !this.ie4 && !this.ie5);
    this.ie6    = (this.ie && (this.major == 4) && (agt.indexOf("msie 6.")!=-1) );
    this.ie6up  = (this.ie  && !this.ie3 && !this.ie4 && !this.ie5 && !this.ie5_5);

    // KNOWN BUG: On AOL4, returns false if IE3 is embedded browser
    // or if this is the first browser window opened.  Thus the
    // variables is.aol, is.aol3, and is.aol4 aren't 100% reliable.
    this.aol   = (agt.indexOf("aol") != -1);
    this.aol3  = (this.aol && this.ie3);
    this.aol4  = (this.aol && this.ie4);
    this.aol5  = (agt.indexOf("aol 5") != -1);
    this.aol6  = (agt.indexOf("aol 6") != -1);

    this.opera = (agt.indexOf("opera") != -1);
    this.opera2 = (agt.indexOf("opera 2") != -1 || agt.indexOf("opera/2") != -1);
    this.opera3 = (agt.indexOf("opera 3") != -1 || agt.indexOf("opera/3") != -1);
    this.opera4 = (agt.indexOf("opera 4") != -1 || agt.indexOf("opera/4") != -1);
    this.opera5 = (agt.indexOf("opera 5") != -1 || agt.indexOf("opera/5") != -1);
    this.opera5up = (this.opera && !this.opera2 && !this.opera3 && !this.opera4);

    this.webtv = (agt.indexOf("webtv") != -1); 

    this.TVNavigator = ((agt.indexOf("navio") != -1) || (agt.indexOf("navio_aoltv") != -1)); 
    this.AOLTV = this.TVNavigator;

    this.hotjava = (agt.indexOf("hotjava") != -1);
    this.hotjava3 = (this.hotjava && (this.major == 3));
    this.hotjava3up = (this.hotjava && (this.major >= 3));

    // *** JAVASCRIPT VERSION CHECK ***
    if (this.nav2 || this.ie3) this.js = 1.0;
    else if (this.nav3) this.js = 1.1;
    else if (this.opera5up) this.js = 1.3;
    else if (this.opera) this.js = 1.1;
    else if ((this.nav4 && (this.minor <= 4.05)) || this.ie4) this.js = 1.2;
    else if ((this.nav4 && (this.minor > 4.05)) || this.ie5) this.js = 1.3;
    else if (this.hotjava3up) this.js = 1.4;
    else if (this.nav6 || this.gecko) this.js = 1.5;
    // NOTE: In the future, update this code when newer versions of JS
    // are released. For now, we try to provide some upward compatibility
    // so that future versions of Nav and IE will show they are at
    // *least* JS 1.x capable. Always check for JS version compatibility
    // with > or >=.
    else if (this.nav6up) this.js = 1.5;
    // note ie5up on mac is 1.4
    else if (this.ie5up) this.js = 1.3

    // HACK: no idea for other browsers; always check for JS version with > or >=
    else this.js = 0.0;

    // *** PLATFORM ***
    this.win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
    // NOTE: On Opera 3.0, the userAgent string includes "Windows 95/NT4" on all
    //        Win32, so you can't distinguish between Win95 and WinNT.
    this.win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));

    // is this a 16 bit compiled version?
    this.win16 = ((agt.indexOf("win16")!=-1) || 
               (agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) || 
               (agt.indexOf("windows 16-bit")!=-1) );  

    this.win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
                    (agt.indexOf("windows 16-bit")!=-1));

    // NOTE: Reliable detection of Win98 may not be possible. It appears that:
    //       - On Nav 4.x and before you'll get plain "Windows" in userAgent.
    //       - On Mercury client, the 32-bit version will return "Win98", but
    //         the 16-bit version running on Win98 will still return "Win95".
    this.win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
    this.winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
    this.win32 = (this.win95 || this.winnt || this.win98 || 
                    ((this.major >= 4) && (navigator.platform == "Win32")) ||
                    (agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1));

    this.winme = ((agt.indexOf("win 9x 4.90")!=-1));
    this.win2k = ((agt.indexOf("windows nt 5.0")!=-1));

    this.os2   = ((agt.indexOf("os/2")!=-1) || 
                    (navigator.appVersion.indexOf("OS/2")!=-1) ||   
                    (agt.indexOf("ibm-webexplorer")!=-1));

    this.mac    = (agt.indexOf("mac")!=-1);
    // hack ie5 js version for mac
    if (this.mac && this.ie5up) this.js = 1.4;
    this.mac68k = (this.mac && ((agt.indexOf("68k")!=-1) || 
                               (agt.indexOf("68000")!=-1)));
    this.macppc = (this.mac && ((agt.indexOf("ppc")!=-1) || 
                                (agt.indexOf("powerpc")!=-1)));

    this.sun   = (agt.indexOf("sunos")!=-1);
    this.sun4  = (agt.indexOf("sunos 4")!=-1);
    this.sun5  = (agt.indexOf("sunos 5")!=-1);
    this.suni86= (this.sun && (agt.indexOf("i86")!=-1));
    this.irix  = (agt.indexOf("irix") !=-1);    // SGI
    this.irix5 = (agt.indexOf("irix 5") !=-1);
    this.irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
    this.hpux  = (agt.indexOf("hp-ux")!=-1);
    this.hpux9 = (this.hpux && (agt.indexOf("09.")!=-1));
    this.hpux10= (this.hpux && (agt.indexOf("10.")!=-1));
    this.aix   = (agt.indexOf("aix") !=-1);      // IBM
    this.aix1  = (agt.indexOf("aix 1") !=-1);    
    this.aix2  = (agt.indexOf("aix 2") !=-1);    
    this.aix3  = (agt.indexOf("aix 3") !=-1);    
    this.aix4  = (agt.indexOf("aix 4") !=-1);    
    this.linux = (agt.indexOf("inux")!=-1);
    this.sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
    this.unixware = (agt.indexOf("unix_system_v")!=-1); 
    this.mpras    = (agt.indexOf("ncr")!=-1); 
    this.reliant  = (agt.indexOf("reliantunix")!=-1);
    this.dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) || 
                  (agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) || 
                  (agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1)); 
    this.sinix = (agt.indexOf("sinix")!=-1);
    this.freebsd = (agt.indexOf("freebsd")!=-1);
    this.bsd = (agt.indexOf("bsd")!=-1);
    this.unix  = ((agt.indexOf("x11")!=-1) || this.sun || this.irix || this.hpux || 
                 this.sco ||this.unixware || this.mpras || this.reliant || 
                 this.dec || this.sinix || this.aix || this.linux || this.bsd || this.freebsd);

    this.vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));
}

function getFlashPluginVersion() 
{ 
  var version = { 
        major: -1, 
        minor: -1, 
        installed: false,
        scriptable: false
      };

  var plugin = navigator.mimeTypes["application/x-shockwave-flash"].enabledPlugin; 
  if (!plugin) 
  {
    return version;
  }

  version.installed = true;

  var description = plugin.description; 
  
  // use RegExp to obtain the relevant version strings 
  // obtain an array of size 2 with version information
  
  var versionArray = description.match(/[\d.]+/g); 
  
  if (!versionArray)
  {
    return version;
  }

  if (versionArray.length >= 1 && !isNaN(versionArray[0]))
  {
    version.major = parseFloat(versionArray[0]);
  }

  if (versionArray.length >= 2 && !isNaN(versionArray[1]))
  {
    version.minor = parseFloat(versionArray[1]);
  }
    
  if (version.major < 6 || navigator.product != 'Gecko')
  {
    return version;
  }

  if (version.major > 6 || version.minor >= 47)
  {
    version.scriptable = true;
  }

  return version;
}

function identifyFlash() 
{ 
  if ((window.ActiveXObject) && 
      (navigator.userAgent.indexOf("MSIE")!= -1) && (navigator.userAgent.indexOf("Windows") != -1))
  {
    alert("This browser is an IE browser which" +
        " supports ActiveX -- this article is about scripting the plugin in Netscape Gecko browsers.");
    return;
  }
  var flashversion = getFlashPluginVersion();

  if (!flashversion.installed)
  {
    alert("Flash is not installed as a plugin. " +
                   "You need to install the latest version available from " +
                   "'http://www.macromedia.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash&P5_Language=English'");
    return;
  }

  if (flashversion.major == -1 || flashversion.minor == -1)
  {
    alert("Flash is installed as a plugin but the version could not be determined.");
    return;
  }

  if (flashversion.scriptable)
  {
    alert("Flash is installed as a plugin and is scriptable in Gecko.");
    return;
  }
  if (!flashversion.scriptable)
  {
	alert("Flash is not scriptable and so the examples in this article will not work ." +
                   "You need to install the latest scriptable version available from " +
                   "'http://www.macromedia.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash&P5_Language=English'");
    return;
  }

  alert("Flash is installed as a plugin and " +
                 "is version " + flashversion.major + "r" +
                 flashversion.minor);
} 


function arrPush(arr, sValue){
	arr[arr.length] = sValue;
	return arr;
}

function arrPop(arr){
	var tmpArr = new Array();
	for (var i=0;i<arr.length-1;i++){
		tmpArr[i] = arr[i];
	}	
	return tmpArr;
}

function CreateHTMLAObject(sAttribs,sParams,sObjType){
	var arrAttribs = sAttribs.split(",");
	var arrParams = sParams.split(",");
	
	
	if (sObjType == "audio"){
		if (m_sAudioSupport == "none"){
			return "";
		}	
	}	

	var sObjTag = "<object ";
	
	for (var i=0;i<arrAttribs.length;i++){
		sObjTag = sObjTag + " " + arrAttribs[i];
	}
	
	sObjTag = sObjTag + ">" ;
	
	for (var i=0;i<arrParams.length;i++){
		if (i % 2 == 0){
			sObjTag = sObjTag + "<param " + arrParams[i] +  " " + arrParams[i+1] + "/>";
		}		
	}
	
	sObjTag = sObjTag + "</object>" ;
	return sObjTag;
}

function DivDocWrite(targetwindow, sValue){
	return targetwindow.document.write(sValue);
}
		
		
function replaceAll(sStr,sFind,sReplace){
	if (sFind == "/"){
		rExp = /\//gi;
    } else if (sFind == "\\"){
		rExp = /\\/gi;
	}else{
		rExp = eval("/" + sFind + "/gi");
	}	
    
	myString = new String(sStr);
	results = myString.replace(rExp, sReplace);
	return results;
}		