﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved

// Begin Audio highlevel API

function AudioPlay(sFrameObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (m_sAudioSupport == "wmp64") {
		windowtarget.document.getElementById(sFrameObjectName).Play();
	} else if (m_sAudioSupport == "wmp71") {
		windowtarget.document.getElementById(sFrameObjectName).controls.play();
	}
}

function AudioStop(sFrameObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (m_sAudioSupport == "wmp64") {
		windowtarget.document.getElementById(sFrameObjectName).Stop();
	} else if (m_sAudioSupport == "wmp71") {
		windowtarget.document.getElementById(sFrameObjectName).controls.stop();
	}
}

function AudioPause(sFrameObjectName,windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (m_sAudioSupport == "wmp64") {
		windowtarget.document.getElementById(sFrameObjectName).Pause();
	} else if (m_sAudioSupport == "wmp71") {
		windowtarget.document.getElementById(sFrameObjectName).controls.pause();
	}
}

function IntroAudioPlay() {
	if (m_sAudioSupport == "wmp64") {
		CP.document.getElementById("AudioPlayer").Play();
	} else if (m_sAudioSupport == "wmp71") {
		CP.document.getElementById("AudioPlayer").controls.play();
	}
}

function IntroAudioStop() {
	if (m_sAudioSupport == "wmp64") {
		CP.document.getElementById("AudioPlayer").Stop();
	} else if (m_sAudioSupport == "wmp71") {
		CP.document.getElementById("AudioPlayer").controls.stop();
	}
}

function IntroAudioPause() {
	if (m_sAudioSupport == "wmp64") {
		CP.document.getElementById("AudioPlayer").pause();
	} else if (m_sAudioSupport == "wmp71") {
		CP.document.getElementById("AudioPlayer").controls.pause();
	}
}

function ToggleAudio(){
	if (AuthorSettingAudio == m_sAudioSupport){
		m_sAudioSupport = "none";
	}else{
		m_sAudioSupport = AuthorSettingAudio;
	}		
}

function AudioPath(sFrameObjectName, sAudPath, windowtarget) {
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (m_sAudioSupport == "wmp64") {
		if (m_bMultiPubRel){
			return windowtarget.document.getElementById(sFrameObjectName).FileName = m_sMultiCourseDir + "/media/" + sAudPath;
		}else{
			return windowtarget.document.getElementById(sFrameObjectName).FileName = m_sContentDir + "/media/" + sAudPath;
		}	
		//return windowtarget.document.getElementById(sFrameObjectName).FileName = getFullURLRelativeToEngine(sAudPath);
	} else if (m_sAudioSupport == "wmp71") {
		if (m_bMultiPubRel){
			return windowtarget.document.getElementById(sFrameObjectName).URL = CP.m_sMultiCourseDir + "/media/" +  sAudPath;
		}else{
			return windowtarget.document.getElementById(sFrameObjectName).URL = m_sContentDir + "/media/" +  sAudPath;
		}			
		//return windowtarget.document.getElementById(sFrameObjectName).url = getFullURLRelativeToEngine(sAudPath);
	}
}

// End Audio highlevel API

// Begin non highlevel API support functions

function getFullURLRelativeToEngine(sPath){
	if (document.location.protocol.toLowerCase() != "http:" && document.location.protocol.toLowerCase() != "https:" && document.location.protocol.toLowerCase() != "file:"){
		return sPath;      
	}
	var sNewPath=document.location.href.substring(0,document.location.href.lastIndexOf("?"));
	sNewPath = sNewPath.substring(0,sNewPath.lastIndexOf("/")+1)
	return sNewPath + sPath;
}

// End non highlevel API support functions
	