﻿	// wrapperjs

function CCookie(sSCOID) {
	if(sSCOID == null || sSCOID == '') {
		sSCOID = "1";
	}
	
	//-------------property declaration-----------------//
	this.id											=	sSCOID;
	this.parentEngine						= parent.engine;
	
	
	//-------------method declaration-----------------//
	this.markCompletionForChildSCO	=	_markCompletionForChildSCO;
	this.navigateChildURL						=	_navigateChildURL;	
	this.navigateParentSCO					=	_navigateParentSCO;
	this.getVisitedString 					= _getVisitedString;
	this.setVisitedStatus 					= _setVisitedStatus;
	this.getCookie									= _getCookie;
	this.setCookie									= _setCookie;
	this.trackCompletionStatusForWrapper	=	_trackCompletionStatusForWrapper;
	
	
	//-------------method definition-----------------//
	function _markCompletionForChildSCO(lEventID,sNavLinkName) {
		// Need to handle if have a cookie set, and if so use that to determine state
		if (this.parentEngine.m_sTracking == "cookies") {
			var cookieStatus = this.getCookie("status");
			if (cookieStatus != null) {
				if (cookieStatus == "c") {
					var objSCOSt = new CSCOStructure(sNavLinkName);
					objSCOSt.markNavLinkAndChildrenVisited('true');
				} else if (cookieStatus == "i") {
					var objEvent = new CEvent(lEventID);
					objEvent.markEventVisited('true');
				}
			}	
		} else if (this.parentEngine.m_sTracking=="none") {
			if (parent.parent.engine.m_arrStatus != null) {
				if (parent.parent.engine.m_arrStatus[escape((this.id).toLowerCase())]==true) {
					var objSCOSt = new CSCOStructure(sNavLinkName);
					objSCOSt.markNavLinkAndChildrenVisited('true');
				} else if (parent.parent.engine.m_arrStatus[escape((this.id).toLowerCase())]==false) {
					var objEvent = new CEvent(lEventID);
					objEvent.markEventVisited('true');
				}
			}	
		}
	}
	
	
	function _navigateChildURL(sURL) {
	   parent.window.location.href = sURL;
	}
	
	function _navigateParentSCO(sURL) {
		if (parent.parent.engine.m_arrVisited != null) {
			parent.parent.engine.m_arrVisited[this.parentEngine.m_sSCOID] = this.parentEngine.getVisitedString();
		}	
	
		parent.window.location.href = sURL;
	}
	
	function _trackCompletionStatusForWrapper(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete) {
		if (parent.parent.engine.m_arrVisited != null) {
			if (parent.parent.engine.m_arrVisited[CP.m_sSCOID] != null) {
				this.parentEngine.setVisitedStatus(parent.parent.engine.m_arrVisited[this.parentEngine.m_sSCOID]);
		
				parent.parent.engine.m_arrVisited[this.parentEngine.m_sSCOID] = null;
			}
		}
		
		if (parent.parent.engine.m_arrStatus != null) {
			var objEvent = new CEvent();
			parent.parent.engine.m_arrStatus[this.parentEngine.m_sSCOID] = objEvent.trackCompletionStatus(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete);
		}	
	}
	
	
	// General functions
	function _getVisitedString() {
		var visitedString = "";
		var colEvents = findEvents();
		for (var i=0; i<colEvents.length;i++) {
			oEventNode = colEvents[i];
	
			visitedChar = "f";
			if (oEventNode.VISITED != null) {
				if (oEventNode.VISITED == "true") {
					visitedChar = "t";
				}
			}
			visitedString = visitedString + visitedChar;
		}
	
		return visitedString;
	}
	
	function _setVisitedStatus(visitedString) {
		var colEvents = findEvents();
		for (var i=0; i<colEvents.length;i++) {
			oEventNode = colEvents[i];
	
			visited = "false";
			if (visitedString.length >= i) {
				if (visitedString.charAt(i) == "t") {
					visited = "true";
				}
			} else {
				// alert that hierarchy has changed
			}
			if (m_arrEvents[String(oEventNode.ID)].VISITED == null) {
				m_arrEvents[String(oEventNode.ID)].VISITED = "false";
			}
			m_arrEvents[String(oEventNode.ID)].VISITED = visited;	
		}
	}
	

	function _setCookie(sItem,sValue,lexpDays){
		var cookieExpires="";
		if ( lexpDays != 0) {
	        expMins = (lexpDays * 24) * 60;
			expDate = new Date();
			expDate.setTime(expDate.getTime() + (expMins*60000))
			cookieExpires = "; expires=" + expDate.toGMTString();
		}
		document.cookie = m_sSCOID + "_" + sItem + "=" + sValue + cookieExpires + ";path=/";    
	}
	
	function _getCookie(sItem){
		sItem = m_sSCOID + "_" + sItem;		
		for( ctx=0;ctx<allCookies.length;ctx++) {
			curCookie = allCookies[ctx].split("=");
			curCookieName = (curCookie[0].charAt(0)==' ') ? curCookie[0].substring(1,curCookie[0].length) : curCookie[0];
			if ( curCookieName == sItem ) {
				return (curCookie.length > 1) ? curCookie[1] : "";
			}
		}
		return "";
	}	
	
	//--------------------------------------------------------//
}	// class