﻿function CDragDrop(targetwindow) {
    var currentX = 0;
    var currentY = 0;
    whichEl = null;
    var arrObjDrop = new Array();
    
    if(targetwindow == null) {
    	this.windowTarget = parent.content;
    } else {
    	this.windowTarget = targetwindow;
    }
    
    //-------------method declaration-----------------//    
    this.prepareDragDrop		=	_prepareDragDrop;
    this.moveEl							= _moveEl;	
    this.checkEl						= _checkEl;
    this.cursEl							=	_cursEl;
    this.grabEl							=	_grabEl;
    this.dropInPlace				=	_dropInPlace;
    this.dropAnywhere				=	_dropAnywhere;
    this.grabEl							=	_grabEl;
    
    
    //-------------method definition-----------------//    
    function _prepareDragDrop(sDragE,bDropOnCorrectOnly,bMoveBack,onDropFunc) {
	    parent.content.document.onmousemove = this.moveEl;
			parent.content.document.onselectstart = this.checkEl;
	    parent.content.document.onmouseover = this.cursEl;
			parent.content.document.onmousedown = this.grabEl;

	    if (bDropOnCorrectOnly == true){
	    	parent.content.document.onmouseup = this.dropInPlace;
	    }else{	
	    	parent.content.document.onmouseup = this.dropAnywhere;
	    	arrObjDrop = new Array();
	    	var sObj = new Object();
	        for (var i = 1;i<parent.content.document.all.length;i++){
	        	sObj = parent.content.document.all(i)
	        	if (sObj.id.indexOf("_drop")>0){
	        		if (sObj.id.substring(sObj.id.length - 5,sObj.id.length) == "_drop"){
	    				arrObjDrop = arrPush(arrObjDrop,sObj);			
	    			}	
	        	}	
	        }
	    }	
	    arrDragE = new Array();
	    if (onDropFunc != null){
	    	arrDragE.onDropFunc = onDropFunc;
		}	    	
	    if (bMoveBack==true){
	    	for (var i=0;i<sDragE.split(",").length;i++){
	    		var sObj = new Object();
	    		sObj.left = parent.content.document.getElementById("div_" + sDragE.split(",")[i].replace(" ","")).style.left;
	    		sObj.top = parent.content.document.getElementById("div_" + sDragE.split(",")[i].replace(" ","")).style.top;
	    		sObj.width = parent.content.document.getElementById("div_" + sDragE.split(",")[i].replace(" ","")).style.width;
	    		sObj.height = parent.content.document.getElementById("div_" + sDragE.split(",")[i].replace(" ","")).style.height;
	    		sObj.name = "div_" + sDragE.split(",")[i].replace(" ","");
	    		sObj.correct = "";
	    		arrDragE = arrPush(arrDragE,sObj);
	    	}
	    }else{
	    	for (var i=0;i<sDragE.split(",").length;i++){
	    		var sObj = new Object();
	    		sObj.left = "";
	    		sObj.top = "";
	    		sObj.width = "";
	    		sObj.height = "";
	    		sObj.name = "div_" + sDragE.split(",")[i].replace(" ","");
	    		sObj.correct = "";
	    		arrDragE = arrPush(arrDragE,sObj);
	    	}
	    }
	    	
    }
    
    
    
    function _grabEl(e) {
        whichEl = parent.content.event.srcElement;
	
        while (whichEl.id.indexOf("div_") == -1) {
            whichEl = whichEl.parentElement;
            if (whichEl == null) { return }
        }
        if (whichEl.parentElement.id.indexOf("div_") >= 0){
        	whichEl = whichEl.parentElement;
        }	 
        var bFound = false;
        for (var i=0;i<arrDragE.length;i++){
        	if (whichEl == parent.content.document.getElementById(arrDragE[i].name)){
        		bFound = true;		
        		break;
        	}	
        }
        if (bFound == false){
        	whichEl = null;	
        	return;
        }	
        	
        whichEl.style.pixelLeft = whichEl.offsetLeft;
        whichEl.style.pixelTop = whichEl.offsetTop;

        currentX = (parent.content.event.clientX + parent.content.document.body.scrollLeft);
        currentY = (parent.content.event.clientY + parent.content.document.body.scrollTop);     
    }
    
    function _moveEl(e) {
        if (whichEl == null) { return };
    
        newX = (parent.content.event.clientX + parent.content.document.body.scrollLeft);
        newY = (parent.content.event.clientY + parent.content.document.body.scrollTop);
        
        distanceX = (newX - currentX);
        distanceY = (newY - currentY);
        currentX = newX;
        currentY = newY;
    
        whichEl.style.pixelLeft += distanceX;
        whichEl.style.pixelTop += distanceY;
        parent.content.event.returnValue = false;

    }
    
    function _checkEl() {
        if (whichEl!=null) { return false }
    }
    
    function _dropEl() {
        whichEl = null;
    }
    
    function _dropInPlace() {
    	if (whichEl != null){
    		bMoveBack = false;
			for (var i=0;i<arrDragE.length;i++){
    			if (whichEl.id == (arrDragE[i].name)){
        			var objDrop = parent.content.document.getElementById(arrDragE[i].name + "_drop");
        			break;
    			}	
    		}       		
    		if (objDrop == null){
    			whichEl = null;
    			return;
    		}	
    		
	        
	        
	        var EL = Number(whichEl.style.left.replace("px",""));
	        var ET = Number(whichEl.style.top.replace("px",""));
	        var EW = Number(whichEl.style.width.replace("px",""));
	        var EH = Number(whichEl.style.height.replace("px",""));
	        var ER = EL + EW;
	        var EB = ET + EH;
        	        
	        var DL = Number(objDrop.style.left.replace("px",""));
	        var DT = Number(objDrop.style.top.replace("px",""));
	        var DW = Number(objDrop.style.width.replace("px",""));
	        var DH = Number(objDrop.style.height.replace("px",""));
	        var DR = DL + DW;
	        var DB = DT + DH;

	        if (EL+(EW/2) > DL && ER-(EW/2) <= DR){
	        	if (ET+(EH/2) >= DT && EB-(EH/2) <= DB){
	        		whichEl.style.left = (DW-EW)/2 + DL + "px";
	        		whichEl.style.top = (DH-EH)/2 + DT + "px";
					for (var i=0;i<arrDragE.length;i++){
            			if (whichEl.id == (arrDragE[i].name)){
	            			arrDragE[i].name = arrDragE[i].name + "_dropped";
	            			arrDragE[i].correct = "true";	
	            			break;
            			}	
            		} 
	        	}else{
	        		bMoveBack = true;
	        	}	
	        }else{
	        	bMoveBack = true;
	        }
	        
	        if (bMoveBack == true){
	        	for (var i=0;i<arrDragE.length;i++){
        			if (whichEl.id == (arrDragE[i].name)){
            			if (convertNull(arrDragE[i].left) != ""){
	        				whichEl.style.left = arrDragE[i].left;
	        				whichEl.style.top = arrDragE[i].top;
	        			}
	        			break;
        			}	
				}
	        	
	        }
	        whichEl = null;
		}
		if (arrDragE.onDropFunc != null){
			eval(arrDragE.onDropFunc);
		}		        
    }

    function _dropAnywhere() {
    	if (whichEl != null){
    		bMoveBack = false;
    		
    		
	        var EL = Number(whichEl.style.left.replace("px",""));
	        var ET = Number(whichEl.style.top.replace("px",""));
	        var EW = Number(whichEl.style.width.replace("px",""));
	        var EH = Number(whichEl.style.height.replace("px",""));
	        var ER = EL + EW;
	        var EB = ET + EH;
	        
	        
	        for (var i=0;i<arrDragE.length;i++){
    			if (whichEl.id == (arrDragE[i].name)){
        			arrDragE[i].correct = "false";
        			break;
    			}	
    		}    
	        	        
	        for (var i=0;i<arrObjDrop.length;i++){
		        var DL = Number(arrObjDrop[i].style.left.replace("px",""));
		        var DT = Number(arrObjDrop[i].style.top.replace("px",""));
		        var DW = Number(arrObjDrop[i].style.width.replace("px",""));
		        var DH = Number(arrObjDrop[i].style.height.replace("px",""));
		        var DR = DL + DW;
		        var DB = DT + DH;
		        
		        if (EL+(EW/2) > DL && ER-(EW/2) <= DR){
		        	if (ET+(EH/2) >= DT && EB-(EH/2) <= DB){
		        		whichEl.style.left = (DW-EW)/2 + DL + "px";
	        			whichEl.style.top = (DH-EH)/2 + DT + "px";
		        		bMoveBack = false;
		        		if (whichEl.id == arrObjDrop[i].id.substring(0,arrObjDrop[i].id.length-5)){
		        			for (var i=0;i<arrDragE.length;i++){
		        				if (whichEl.id == (arrDragE[i].name)){
        							arrDragE[i].correct = "true";
        							break;
        						}	
    						}	
    					}
		        		break;
		        	}else{
		        		bMoveBack = true;
		        	}	
		        }else{
		        	bMoveBack = true;
		        }
	        }
	        
	        if (bMoveBack == true){
	        	for (var i=0;i<arrDragE.length;i++){
        			if (whichEl.id == (arrDragE[i].name)){
            			if (convertNull(arrDragE[i].left) != ""){
	        				whichEl.style.left = arrDragE[i].left;
	        				whichEl.style.top = arrDragE[i].top;
	        			}
	        			break;
        			}	
				}
	        	
	        }
	        
	        whichEl = null;
		}
		if (arrDragE.onDropFunc != null){
			eval(arrDragE.onDropFunc);
		}		        
    }
    
    function _cursEl() {
        if (parent.content.event.srcElement.id.indexOf("DRAG") != -1) {
            parent.content.event.srcElement.style.cursor = "move";
        }
    }
    
    //----------------------------------------------------//	
}			// class    
    
