﻿function CFrameObject(sFrameObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.frameObject							=	sFrameObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	this.window;
	} else {
		this.windowTarget							=	targetwindow;
	}
	
	var objUtil = new CUtil();
	
	//-------------method declaration-----------------//
	this.getCurrentFrameObjectName		=	_getCurrentFrameObjectName;
	this.getVisibility								=	_getVisibility;
	this.setVisibility								=	_setVisibility;
	this.setObjectZIndex							=	_setObjectZIndex;
	this.getObjectZIndex							=	_getObjectZIndex;
	this.moveObject										=	_moveObject;
	this.resizeFrameObject						=	_resizeFrameObject;
	this.getLayerNameForObject				=	_getLayerNameForObject;
	
	this.getFrameObjectElement				=	_getFrameObjectElement;
	this.isFrameObjectExists					=	_isFrameObjectExists;
	this.isObjectGroupExists					=	_isObjectGroupExists;

	this.replaceWithExpression				=	_replaceWithExpression;
	this.replaceWithContent						=	_replaceWithContent;
	this.replaceButtonWithExpression	=	_replaceButtonWithExpression;
	this.replaceWithCourseName				=	_replaceWithCourseName;
	this.replaceWithEventName					=	_replaceWithEventName;
	this.replaceWithParentEventName		=	_replaceWithParentEventName;
	this.replaceWithParentNavName			=	_replaceWithParentNavName;
	this.replaceWithBreadcrumbs				=	_replaceWithBreadcrumbs;
	this.replaceButtonWithNavName			=	_replaceButtonWithNavName;
	this.getContent										=	_getContent;
	this.setContent										=	_setContent;

	// new
	this.getPositionAndSize						=	_getPositionAndSize;
		
	//-------------method definition-----------------//
	function initialize() {
		if(sFrameObject == '[object]') {
			sFrameObject = sFrameObject.id.substring(4);
		}
	}	
	
	function _getCurrentFrameObjectName() {
		return this.frameObject;
	}
	
	/*function _getCurrentFrameObjectName(obj) {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}
		
		return obj.id.substring(4);
	}*/
	
	function _setVisibility(sState) {	
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}
				
		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);

		if (domStyle != null) {
			domStyle.visibility = sState;
		}
	}	
	
	
	function _getVisibility() {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}		

		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
		
		if (domStyle != null) {
				return domStyle.visibility;
		} else {
      	return "";
    }
	}
	
	
	function _setObjectZIndex(nZIndex) {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}		
				
		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
		if (domStyle != null) {
			domStyle.zIndex = nZIndex;
		}	
	}
	
	function _getObjectZIndex() {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}		
				
		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
		if (domStyle != null) {
			if (domStyle.zIndex != null) {
				return domStyle.zIndex;
			}
		}	
		return null;
	}	
	
	
	function _moveObject(x,y) {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}		
				
		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
		if (domStyle != null) {
			domStyle.left = String(x) + "px";
			domStyle.top = String(y) + "px";
		}			
	}
	
	
	function _resizeFrameObject(x,y,width,height) {		
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}		
				
		if (this.windowTarget == null) {
			this.windowTarget = parent.content;
		}
		
		domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
		if (domStyle != null) {
			var nOldWidth = parseInt(domStyle.width);
			var nOldHeight = parseInt(domStyle.height);
	
			domStyle.width = width + "px";
			domStyle.height = height + "px";
			domStyle.left = x + "px";
			domStyle.top = y + "px";
			
			var sType = this.windowTarget.arrContent[this.frameObject].TYPE;
			if (sType.toLowerCase() == "multistatebutton"){
				if (this.windowTarget.document.getElementById("btn_" + this.frameObject) != null) {
					this.windowTarget.document.getElementById("btn_" + this.frameObject).width = width;
					this.windowTarget.document.getElementById("btn_" + this.frameObject).height = height;
				}	
				if (this.windowTarget.document.getElementById("div_lbl_" + this.frameObject) != null) {
					var lblStyle = this.windowTarget.document.getElementById("div_lbl_" + this.frameObject).style;
				
					var nOldGutterRight = nOldWidth - (parseInt(lblStyle.left) + parseInt(lblStyle.width));
					var nOldGutterBottom = nOldHeight - (parseInt(lblStyle.top) + parseInt(lblStyle.height));
					
					this.windowTarget.document.getElementById("div_lbl_" + this.frameObject).style.width = String(width-nOldGutterRight) + "px";
					this.windowTarget.document.getElementById("div_lbl_" + this.frameObject).style.height = String(height-nOldGutterBottom) + "px";
				}	
			}else if(sType.toLowerCase() == "image" || sType.toLowerCase() == "multistateimage"){
				if (this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild != null) {
					this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.width = width;
					this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.height = height;
				}	
			}else if (sType.toLowerCase() == "video" || sType.toLowerCase() == "flash" || sType.toLowerCase() == "audio" || sType.toLowerCase() == "iframe" || sType.toLowerCase() == "simulation") {
				if (this.windowTarget.document.getElementById(this.frameObject) != null) {
					this.windowTarget.document.getElementById(this.frameObject).width = width;
					this.windowTarget.document.getElementById(this.frameObject).height = height;
				}	
			}else if (sType.toLowerCase() == "hotspot") {
				if (this.windowTarget.document.getElementById("spt_" + this.frameObject) != null) {
					this.windowTarget.document.getElementById("spt_" + this.frameObject).width = width;
					this.windowTarget.document.getElementById("spt_" + this.frameObject).height = height;
				}	
			}else if (sType.toLowerCase() == "editbox") {
				if (this.windowTarget.document.getElementById(this.frameObject) != null) {
					var editStyle = this.windowTarget.document.getElementById(this.frameObject).style;
				
					editStyle.width = String(width-5) + "px";
					editStyle.height = String(height-5) + "px";
				}	
			}
		}	
	}
	
	
	function _getLayerNameForObject() {
		if(this.isFrameObjectExists() == false) {
			return objUtil.handleError(this.frameObject);
		}
		
		var objLayer;
		
		for (objLayer in this.windowTarget.arrCPLayers) {
				var obj;
				
				for (obj in this.windowTarget.arrCPLayers[objLayer].OBJECTS) {
					if (obj != null) {
						if (obj == this.frameObject){
							return this.windowTarget.arrCPLayers[objLayer].NAME;
						}
					}	
				}	
		}
	}
	

	function _isFrameObjectExists() {
		// check frame objects in the current event and merged event also
		var oEvent = new CEvent(this, this.windowTarget);
		for(i in oEvent.arrFrameObjects) {
			if(i == this.frameObject) {
				return true;
			} 
		}
		
		// check frame objects only in current event
		if(this.getFrameObjectElement() == null) {
			return false;
		} else {
			return true;
		} 
	}


	function _isObjectGroupExists() {
		if(this.windowTarget.document.getElementsByName(this.frameObject).length == 0) {
			return false;
		} else {
			return true;
		}
	}
	

	function _getFrameObjectElement() {
		if(this.windowTarget == this.window) {
			this.windowTarget = parent.content;
		}
		return this.windowTarget.document.getElementById("div_" + this.frameObject);
	}

	
	//dom.js
	function _replaceWithExpression(sExpr) {
		objectID = "div_" + this.frameObject;
		if (this.windowTarget.document.getElementById(objectID).firstChild.nodeName != "#text") {
			this.windowTarget.document.getElementById(objectID).firstChild.innerHTML = sExpr;
		} else {
			this.windowTarget.document.getElementById(objectID).innerHTML = sExpr;
	    }
	}
	
	function _replaceWithContent(sSrcFrameListObjectName,bKeepFormatting,srcwindowtarget) {
		if (bKeepFormatting == null) {
			bKeepFormatting = true;
		}
		if (srcwindowtarget == null) {
			srcwindowtarget = parent.content;
		}
	
		if (bKeepFormatting) {
	        if (this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.nodeName != "#text") {
			    this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).firstChild.innerHTML;
	        } else {
			    this.windowTarget.document.getElementById("div_" + this.frameObject).innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).innerHTML;
	        }        
		} else {
	        if (this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.nodeName != "#text") {
			    	this.windowTarget.document.getElementById("div_" + this.frameObject).firstChild.innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).firstChild.innerText;
	        } else {
			    	this.windowTarget.document.getElementById("div_" + this.frameObject).innerHTML = srcwindowtarget.document.getElementById("div_" + sSrcFrameListObjectName).innerText;
	        }
		}	
	}
	

	function _replaceButtonWithExpression(sExpr) {
		objectID = "div_lbl_" + this.frameObject;
		if (this.windowTarget.document.getElementById(objectID).firstChild.firstChild.nodeName != "#text") {
			this.windowTarget.document.getElementById(objectID).firstChild.firstChild.innerHTML = sExpr;
		} else {
			this.windowTarget.document.getElementById(objectID).firstChild.innerHTML = sExpr;
		}
	}
	

	function _replaceWithCourseName() {
		var objSCO = new CSCO();
		this.replaceWithExpression(objSCO.getName());
	}
	
	function _replaceWithEventName() {
		var objEvent = new CEvent();
		this.replaceWithExpression(objEvent.getName());
	}
	
	function _replaceWithParentEventName() {
		var objEvent = new CEvent();
		this.replaceWithExpression(objEvent.getParentName());
	}
	
	function _replaceWithParentNavName() {
		 var objSCOSt = new CSCOStructure();
		 this.replaceWithExpression(objSCOSt.getParentNavName());
	}
	
	function _replaceWithBreadcrumbs() {
		var objSCOSt = new CSCOStructure();
		var objectID = "div_" + this.frameObject;
		var objEvent = findEvent(m_lAliasID);
		if (this.windowTarget.document.getElementById(objectID) != null) {
			this.windowTarget.document.getElementById(objectID).innerHTML = objSCOSt.buildBreadcrumb(m_lAliasID,objEvent.NAME + " ");
		}
	}
	
	function _replaceButtonWithNavName(nIndex) {
		var objEvent = new CEvent();   
		this.replaceButtonWithExpression(objEvent.getButtonNavName(nIndex));
	}
	
	function _getContent(bKeepFormatting) {
		if (bKeepFormatting == null) {
			bKeepFormatting = true;
		}

		var obj = this.windowTarget.document.getElementById("div_" + this.frameObject);
		if (obj != null) {
			if (bKeepFormatting) {
				if (obj.firstChild.nodeName != "#text") {
					return obj.firstChild.innerHTML;
				} else {
					return obj.innerHTML;
				}	
			} else {
				if (obj.firstChild.nodeName != "#text") {
					return obj.firstChild.innerText;
				} else {
					return obj.innerText;
				}
			}
		} else {
			if(m_debug == true) {
				alert("Error! The object " + this.frameObject + " doesn't exist.");
			}
			return "";
		}
	}
	
	function _setContent(sContent) {
		var obj = this.windowTarget.document.getElementById("div_" + this.frameObject);
		if (obj != null) {
			if (obj.firstChild.nodeName != "#text") {
				obj.firstChild.innerHTML = sContent;
			} else {
				obj.innerHTML = sContent;
			}	
		}
	}

	// new
	function _getPositionAndSize() {
	  var objPosAndSize = new Object();
	
	  var domStyle = findDOM("div_" + this.frameObject,1,this.windowTarget);
	  if (domStyle != null) {
	    objPosAndSize.top = parseInt(domStyle.top);
	    objPosAndSize.left = parseInt(domStyle.left);
	    objPosAndSize.width = parseInt(domStyle.width);
	    objPosAndSize.height = parseInt(domStyle.height);
	    return objPosAndSize;
	  } else {
	    return null;
	  }
	}
	
	//----------------------------------------------------//
}			// class