﻿function CInlineFrame(sIFrameObject,targetwindow) {
	//-------------property declaration-----------------//
	this.iFrameObject									=	sIFrameObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}


	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.iFrameObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	
	if(this.windowTarget.arrContent[this.iFrameObject] != null) {
		this.filename											=	this.windowTarget.arrContent[this.iFrameObject].FILENAME;
		this.allowTransparency						=	this.windowTarget.arrContent[this.iFrameObject].ALLOWTRANSPARENCY;	
		this.frameBorder									=	this.windowTarget.arrContent[this.iFrameObject].FRAMEBORDER;
		this.scrolling										=	this.windowTarget.arrContent[this.iFrameObject].SCROLLING;
	}

		
	//-------------method declaration-----------------//
	this.getIFrameFilename						=	_getIFrameFilename;
	this.setIFrameURL									=	_setIFrameURL;
	this.getIFrameAllowTransparency		=	_getIFrameAllowTransparency;
	this.getIFrameFrameBorder					=	_getIFrameFrameBorder;
	this.getIFrameScrolling						=	_getIFrameScrolling;
	

	//------------methods from class inheritance-----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };	
	
	//-------------method definition-----------------//	
	function _getIFrameFilename() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.iFrameObject);
		}		
		
		return this.filename;
	}
	
	function _setIFrameURL(sURL) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.iFrameObject);
		}		
		this.windowTarget.arrContent[this.iFrameObject].FILENAME = sURL;
		
		var obj = this.windowTarget.document.getElementById("div_" + this.iFrameObject);
		if (obj != null) {
			obj.firstChild.src = sURL;
		}		
	}	
	
	function _getIFrameAllowTransparency() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.iFrameObject);
		}		
		
		return this.allowTransparency;
	}	
	
	function _getIFrameFrameBorder() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.iFrameObject);
		}		
		
		return this.frameBorder;
	}
	
	function _getIFrameScrolling() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.iFrameObject);
		}		
		
		return this.scrolling;
	}
		
	//----------------------------------------------------//	
	
}			// class
					