﻿function CSCO(sSCOID) {
	if(sSCOID == null || sSCOID == '') {
		sSCOID = "1";
	}
	
	
	//-------------property declaration-----------------//
	this.id													=	sSCOID;
	if(m_arrNavs[this.id] != null) {
		this.name												= m_arrNavs[this.id].ALIASNAME;
	}
	
	this.persistData								=	m_bPersistData;
	this.audioSupport								=	m_sAudioSupport;
	this.useCompletionStatus				=	m_bUseCompletionStatus;
	this.navigationBehaviour				=	m_sNavigationBehavior;
	this.usesCourseTree							=	m_bUsesCourseTree;
	this.publishedFilename					=	m_sPublishedFilename;
	this.publishedExtension					=	m_sPublishedExtension;
	this.useNewWindow								=	m_bUseNewWin;
	this.windowWidth								=	m_nBrowserWidth;
	this.windowHeight								=	m_nBrowserHeight;
	this.trackingType								=	m_sTracking;
	this.HACPAppletURLAuthored			=	m_sHACPAppletURLAuthored;
	this.reportInteraction					=	m_bReportInteraction;
	this.cacheInteractionData				=	m_bCacheInteractionData;
	this.useBookmarking							=	m_bUseBookmarking;
	this.mergeContent								=	m_sMergeContent;
	this.mergeFrameList							=	m_sMergeFrameList;
	this.mergeLayout								=	m_sMergeLayout;
	this.target											=	m_sTarget;
	this.ignoreFontStyles						=	m_bIgnoreFontStyles;
	this.hyperlinkColor							=	m_rgbLinkColor;
	this.visitedLinkColor						=	m_rgbVLinkColor;
	this.custom1										=	m_sCustom1;
	this.custom2										=	m_sCustom2;
	this.custom3										=	m_sCustom3;
	
	//-------------class inheritance-----------------//	
	this.objUtil										=	new CUtil();
	
	//-------------method declaration-----------------//	
	this.setName										=	_setName;
	this.setPersistData 						= _setPersistData;
	this.setAudioSupport 						= _setAudioSupport;
	this.setUseCompletionStatus 		= _setUseCompletionStatus;
	this.setNavigationBehaviour 		= _setNavigationBehaviour;
	this.setUsesCourseTree 					= _setUsesCourseTree;
	this.setTrackingType 						= _setTrackingType;
	this.setReportInteraction 			= _setReportInteraction;
	this.setCacheInteractionData 		= _setCacheInteractionData;

	this.getName										=	_getName;
	this.getPersistData 						= _getPersistData;
	this.getAudioSupport						=	_getAudioSupport;
	this.getUseCompletionStatus 		= _getUseCompletionStatus;
	this.getNavigationBehaviour 		= _getNavigationBehaviour;
	this.getUsesCourseTree 					= _getUsesCourseTree;
	this.getPublishedFilename 			= _getPublishedFilename;
	this.getPublishedExtension 			= _getPublishedExtension;
	this.getTrackingType 						= _getTrackingType;
	this.getMergeContent 						= _getMergeContent;
	this.getMergeFrameList 					= _getMergeFrameList;
	this.getMergeLayout 						= _getMergeLayout;	
	this.isAudioSupported 					= _isAudioSupported;
	this.isReportInteracted 				= _isReportInteracted;
	this.isCacheInteracted 					= _isCacheInteracted;
	this.isBookmarkUsed 						= _isBookmarkUsed;
	this.isHACPAppletURLAuthored 		= _isHACPAppletURLAuthored;

	// new
	//this.getTotalEventsInSCO				=	_getTotalEventsInSCO;
	
	this.getURL				 							= _getURL;										// GetURLForSCO
	this.getURLForEvent							=	_getURLForEvent;
	this.getURLForEventAndFrame			=	_getURLForEventAndFrame;
	this.launchSCO									=	_launchSCO;
	this.exitSCO										=	_exitSCO;

/*
	this.getObjective								=	_getObjective;
	this.getAssessment							=	_getAssessment;
	
	function _getObjective(sObjectiveID) {
		var objObjective = new CObjective(sObjectiveID);
		return objObjective;
	}
		
	function _getAssessment(sAssessID) {
		var objAssessment = new CAssessment(sAssessID);
		return objAssessment;
	}
*/	
	
	//-------------method definition-----------------//
	function _setName(sName) {
			this.name = sName;
			m_arrNavs[this.id].ALIASNAME = this.name;
	}

	function _setPersistData(bVal) {
		this.persistData	=	bVal;
		m_bPersistData 		= this.persistData;
	}
	
	function _setAudioSupport(sVal) {
		this.audioSupport	=	sVal;
		m_sAudioSupport 	= this.audioSupport;
	}
	
	function _setUseCompletionStatus(bVal) {
		this.useCompletionStatus 		= bVal;
		m_bUseCompletionStatus			=	this.useCompletionStatus;
	}
	
	function _setNavigationBehaviour(sVal) {
		this.navigationBehaviour	=	sVal;
		m_sNavigationBehavior 		= this.navigationBehaviour;
	}
	
	function _setUsesCourseTree(bVal) {
		this.usesCourseTree		=	bVal
		m_bUsesCourseTree 		= this.usesCourseTree;
	}
		
	function _setTrackingType(sVal) {
		this.trackingType		=	sVal;
		m_sTracking					=	this.trackingType;
	}
		
	function _setReportInteraction(bVal) {
		this.reportInteraction		=	bVal;
		m_bReportInteraction			=	this.reportInteraction;
	}
	
	function _setCacheInteractionData(bVal) {
		this.cacheInteractionData		=	bVal;
		m_bCacheInteractionData			=	this.cacheInteractionData;
	}	
	
	function _getName() {
		return this.name;		
	}
	
	function _getPersistData() {
		return this.persistData;
	}
	
	function _getAudioSupport() {
		return this.audioSupport;
	}
	
	function _getUseCompletionStatus() {
		return this.useCompletionStatus;
	}
	
	function _getNavigationBehaviour() {
		return this.navigationBehaviour;
	}
	
	function _getUsesCourseTree() {
		return this.usesCourseTree;
	}
	
	function _getPublishedFilename() {
		return this.publishedFilename;
	}
	
	function _getPublishedExtension() {
		return this.publishedExtension;
	}
	
	function _getTrackingType() {
		return this.trackingType;
	}
		
	function _getMergeContent() {
		return this.mergeContent;
	}
	
	function _getMergeFrameList() {
		return this.mergeFrameList;
	}
	
	function _getMergeLayout() {
		return this.mergeLayout;
	}

	function _isAudioSupported() {
			if(this.audioSupport == "No Support") {
				return false;	
			}
			else {
				return true;
			}
	}
	
	
	function _isReportInteracted() {
		return Boolean(this.reportInteraction);
	}
	
	
	function _isCacheInteracted() {
		return Boolean(this.cacheInteractionData);
	}
	
	
	function _isBookmarkUsed() {
		return Boolean(this.useBookmarking);
	}
	
	function _isHACPAppletURLAuthored() {
		return Boolean(this.HACPAppletURLAuthored);
	}
	
	function _getURL() {
    	return "scos/" + this.objUtil.replaceAll(this.id,"\\","/") + "/index.htm?tracking=none";
	}
	
	
	function _getURLForEvent(sEventID) {
		var oEvent = new CEvent(sEventID,this.windowTarget);
		nEventID = oEvent.id;
		return "scos/" + this.objUtil.replaceAll(this.id,"\\","/") + "/index.htm?eventref=" + nEventID + "tracking=none";
	}


	function _getURLForEventAndFrame(sEventID, sFrameID) {
		var oEvent = new CEvent(sEventID,this.windowTarget);
		nEventID = oEvent.id;
		nFrameID = oEvent.getFrame(sFrameID).getIndex();
		return "scos/" + this.objUtil.replaceAll(this.id,"\\","/") + "/index.htm?eventref=" + nEventID + "&framenum=" + nFrameID + "tracking=none";
	}	
	
	
	function _launchSCO(sPath,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status) {
		sPath = this.objUtil.replaceAll(sPath,"\\","/") + "/index.htm?tracking=none";
		this.objUtil.openReusableWindowAndCenter(sPath,windowNumber,width,height,centertop,resizable,scrollbars,toolbar,menubar,location,status,false);
	}
	
	function _exitSCO() {
		parent.close();		
	}	
	
	//----------------------------------------------------//
	
}			// class
